//+------------------------------------------------------------------+
//|                                             Angle of average.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"

#property  indicator_separate_window
#property  indicator_buffers 6
#property  indicator_color1  Green
#property  indicator_color2  Crimson
#property  indicator_color3  White
#property  indicator_color4  Lime
#property  indicator_color5  Red
#property  indicator_color6  White
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2
#property  indicator_width5  2
#property  indicator_width6  2

//
//
//
//
//

extern int    MA.Period        =  21;
extern int    MA.Type          =   3; // 4 -> LSMA
extern int    MA.AppliedPrice  =   4;
extern double AngleLevel       =   6;
extern int    AngleBars        =   2;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];
double constant;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//
#define Pi 3.141592653589793238462643

//
//
//
//
//

int init()
{
   constant=180.0/Pi;
   
   
   
   IndicatorBuffers(6);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Buffer4); SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(4,Buffer5); SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(5,Buffer6); SetIndexStyle(5,DRAW_LINE);

   //
   //
   //
   //
   //
      
   string  MAType;
   switch (MA.Type)
   {
      case 1:  MAType="EMA";  break;
      case 2:  MAType="SMMA"; break;
      case 3:  MAType="LWMA"; break;
      case 4:  MAType="LSMA"; break;
      default: MAType="SMA";  break;
   }
   IndicatorShortName(MAType+" angle ("+MA.Period+","+DoubleToStr(AngleLevel,2)+","+AngleBars+")");
   IndicatorDigits(2);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
   int limit, i;
 
   if(countedBars<0) return(-1);
   if(countedBars>0) countedBars--;
      limit = Bars-countedBars;

   //
   //
   //
   //
   //
   int previous;
   for(i=limit; i>=0; i--)
   {
      previous=i+1;
      double range = iATR(NULL,0,AngleBars*20,i);
      double angle = 0.00;
      double change;
         if (MA.Type == 4)
               change = iLSMA(MA.Period,MA.AppliedPrice,i)                 -iLSMA(MA.Period,MA.AppliedPrice,i+AngleBars);
         else  change = iMA(NULL,0,MA.Period,0,MA.Type,MA.AppliedPrice,i)  -iMA(NULL,0,MA.Period,0,MA.Type,MA.AppliedPrice,i+AngleBars);

         if (range != 0) angle = MathArctan(change/(range*AngleBars))*constant;

      //
      //
      //
      //
      //
      
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = angle;
            if (angle >  AngleLevel) { Buffer1[i] = angle; Buffer3[i] = EMPTY_VALUE;}
            if (angle < -AngleLevel) { Buffer2[i] = angle; Buffer3[i] = EMPTY_VALUE;}
         
         
         Buffer4[i] = angle;
         Buffer5[i] = EMPTY_VALUE;
         Buffer6[i] = EMPTY_VALUE;
         Buffer5[previous]=Buffer5[i];
         Buffer6[previous]=Buffer6[i];
            if(Buffer4[i] < Buffer4[previous])              {   Buffer5[i]=angle;   Buffer5[previous]=Buffer4[previous];  }
            if (angle < AngleLevel && angle > -AngleLevel)  {   Buffer6[i]=angle;   Buffer6[previous]=Buffer4[previous];  }
     }   
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iLSMA(int period,int appliedPrice,int shift)
{
   double lengthvar = (period + 1.0)/3.0;
   double sum       = 0.0;

   for(int i = period; i >= 1 ; i--)
      sum += (i-lengthvar)*iMA(NULL,0,1,0,MODE_SMA,appliedPrice,shift+period-i);
   return(sum*6.0/(period*(period+1.0)));
}