//+------------------------------------------------------------------+
//|                                              ID Lite Info MA.mq4 |
//|                                                2015, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "2015, Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#property version   "1.86"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
//+------------------------------------------------------------------+
/*    ,    
     (>=2 or <=30):*/
#define ARRAY_SIZE_X     (9)  
#define ARRAY_SIZE_Y     (6) //       Y
#define DISTANCE_XY      (1)//   
#define COUNT_BUFFERS    (2)//  ( Moving Averages)
#define LINE_NUMBER      "Line: ",__LINE__,", "
//+------------------------------------------------------------------+
//|       :              |
//+------------------------------------------------------------------+
enum varDigits
  {
   auto=-1,//current chart
   dig0=0,//0
   dig1=1,//1
   dig2=2,//2
   dig3=3,//3
   dig4=4,//4
   dig5=5,//5
   dig6=6,//6
   dig7=7,//7
   dig8=8,//8
  };
//+------------------------------------------------------------------+ 
/*      :*/
input bool showLine=true;//Show lines MA

/*     :*/
input int indent1=0;//Shift in points from MA1 (-/+ Down or Up)

/*     :*/
input int indent2=0;//Shift in points from MA2 (-/+ Down or Up)

/*       :*/
input varDigits digCh=auto;//Decimal digits

/*    :*/
input int shift=1;//Shift (bar for first value): 

sinput string stripe1="+++++++++++++++++++++";//+++++++++++++++++++++
/*  :*/
input int ma_period1=1;//Period Moving Averages (1)>= 1 or <= 3000:

/*     :*/
input ENUM_MA_METHOD ma_method1=MODE_SMA;//MA method (1):

/*     :*/
input ENUM_APPLIED_PRICE applied_price1=PRICE_HIGH;//Apply to (1):

sinput string stripe2="+++++++++++++++++++++";//+++++++++++++++++++++
/*  :*/
input int ma_period2=1;//Period Moving Averages (2)>= 1 or <= 3000:

/*     :*/
input ENUM_MA_METHOD ma_method2=MODE_SMA;//MA method (2): 

/*     :*/
input ENUM_APPLIED_PRICE applied_price2=PRICE_LOW;//Apply to (2):

sinput string stripe3="+++++++++++++++++++++";//+++++++++++++++++++++
/*     :*/
input int xDistance=3;//X coordinate

/*     :*/
input int yDistance=3;//Y coordinate

/*       ,
     :*/
input color backClrMain=C'224,224,224';// background color (table and Equal)

/*   ,     :*/
input color backClrUp=clrCornflowerBlue;//background color (Up)

/*   ,     :*/
input color backClrDown=C'255,85,85';//background color (Down)

/*    :*/
input color textClrMA=C'48,48,48';//text color for MA

/*    ,
    :*/
input color textClrDelta=clrDimGray;// color text for delta

/*     :*/
input int widthObj=60;//width

/*         Y:*/
input int heightObj=18;//height

/*    :*/
input int fontSize=9;//font size

/*     */
input bool backObj=true;//in the background
//+------------------------------------------------------------------+
double priceM1buffer[],priceM2buffer[],indentK1,indentK2,pointK;
int dig,minBars,shiftK,switchButtonClick,chartWidthK,switchMA1,switchMA2,
coordinateY0,coordinateY1,coordinateX0,coordinateX1;
color backClrObjOddY[COUNT_BUFFERS+1][ARRAY_SIZE_X],
textClrObjEvenY[COUNT_BUFFERS][ARRAY_SIZE_X];
string prefixObj,symb,
nameObj[ARRAY_SIZE_Y][ARRAY_SIZE_X],
textObjOddY[COUNT_BUFFERS+1][ARRAY_SIZE_X],
textObjEvenY[COUNT_BUFFERS][ARRAY_SIZE_X],
nameObjBut0,nameObjBut1;
bool changeClr0[ARRAY_SIZE_X],changeClr1[ARRAY_SIZE_X];
ENUM_TIMEFRAMES timeframe1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   symb=Symbol();
   prefixObj=StringConcatenate("vMA(",IntegerToString(COUNT_BUFFERS),
                               "):",symb,"_",xDistance,yDistance);
   IndicatorSetString(INDICATOR_SHORTNAME,prefixObj);
//+------------------------------------------------------------------+
   if(!SetOnInitAny())return(INIT_FAILED);
//+------------------------------------------------------------------+
   SetOnInitTable();
//+------------------------------------------------------------------+
/*   :*/
   SetIndexBuffer(0,priceM1buffer,INDICATOR_DATA);
   SetIndexBuffer(1,priceM2buffer,INDICATOR_DATA);

   if(showLine==true)//       
     {
      for(int i=0;i<COUNT_BUFFERS;i++)
        {SetIndexStyle(i,DRAW_LINE,STYLE_SOLID,1,backClrMain);}
     }
   else//        
     {
      for(int i=0;i<COUNT_BUFFERS;i++)
        {SetIndexStyle(i,DRAW_NONE);}
     }
/*  ,   " ":*/
   string textLabel1=StringConcatenate(COUNT_BUFFERS-1,
                                       " MA(",
                                       IntegerToString(ma_period1),"):");
   string textLabel2=StringConcatenate(COUNT_BUFFERS,
                                       " MA(",
                                       IntegerToString(ma_period2),"):");
   SetIndexLabel(0,textLabel1);
   SetIndexLabel(1,textLabel2);
   IndicatorSetInteger(INDICATOR_DIGITS,dig);

   for(int i=0;i<COUNT_BUFFERS;i++){SetIndexEmptyValue(i,0.0);}
//+------------------------------------------------------------------+
   return(INIT_SUCCEEDED);
  }//int OnInit()
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
/* ,        
 ,  840-  4:*/
   ObjectsDeleteAll(0,prefixObj,0,EMPTY);
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   if(prev_calculated<0) return(0);
   if(rates_total-1<minBars) return(0);
//+------------------------------------------------------------------+
/*    :*/
   bool asSeriesFirst=ArrayGetAsSeries(time);
/*    ,    */
   if(!asSeriesFirst)
     {ArraySetAsSeries(time,true);}
//+------------------------------------------------------------------+
   static datetime timeNewBar=0;
   static color clrK1=0;//     
   static color clrK2=0;//     
   int limit=0;
//+------------------------------------------------------------------+
   if(prev_calculated==0)
     {
      for(int i=0;i<COUNT_BUFFERS;i++){SetIndexEmptyValue(i,0.0);}

      limit=ARRAY_SIZE_X+shiftK+1;
      timeNewBar=0;
     }
   else {limit=rates_total-prev_calculated+shiftK;}
//+------------------------------------------------------------------+
   if(timeNewBar!=time[0])
     {
      timeNewBar=time[0];
/*+------------------------------------------------------------------+
      ( 
):*/
      bool asSeriesBuffer1=ArrayGetAsSeries(priceM1buffer);
      bool asSeriesBuffer2=ArrayGetAsSeries(priceM2buffer);
/*    ,    */
      if(!asSeriesBuffer1)
        {ArraySetAsSeries(priceM1buffer,true);}
      if(!asSeriesBuffer2)
        {ArraySetAsSeries(priceM2buffer,true);}
/*+------------------------------------------------------------------*/
      for(int i=0;i<COUNT_BUFFERS;i++)
        {SetIndexDrawBegin(i,rates_total-(ARRAY_SIZE_X+shiftK+1));}
      //+------------------------------------------------------------------+
      if(!IsStopped())
        {
         switch(switchMA1)
           {
/*   = MODE_SMA + period Moving Averages = 1 +                                     
applied_price = PRICE_CLOSE/PRICE_OPEN/PRICE_HIGH/PRICE_LOW:*/
            case 0:PriceSwitchForBuffer(priceM1buffer,applied_price1,
                                        indentK1,limit);break;
               /*,   Moving Averages  iMA:*/
            case 1:PriceIMAforBuffer0(priceM1buffer,ma_period1,ma_method1,
                                      applied_price1,indentK1,limit);break;
               default:break;
           }
         //+------------------------------------------------------------------+
         switch(switchMA2)
           {
/*   = MODE_SMA + period Moving Averages = 1 +                                      
applied_price = PRICE_CLOSE/PRICE_OPEN/PRICE_HIGH/PRICE_LOW:*/
            case 0: PriceSwitchForBuffer(priceM2buffer,applied_price2,
                                         indentK2,limit);break;
               /*,   Moving Averages  iMA:*/
            case 1:PriceIMAforBuffer0(priceM2buffer,ma_period2,ma_method2,
                                      applied_price2,indentK2,limit);break;
               default:break;
           }
/*+------------------------------------------------------------------+
       :*/
         int newValues=MathMin(limit-shiftK,ARRAY_SIZE_X);
         if(newValues>0)
           {
            ChangeValuesTable0(1,priceM1buffer,0,newValues,changeClr0,clrK1);
            ChangeValuesTable0(3,priceM2buffer,1,newValues,changeClr1,clrK2);
            ChangeValuesTable1(5,priceM1buffer,priceM2buffer,2,newValues);
           }
/*+------------------------------------------------------------------+*/
        }
     }//  if(timeNewBar!=time[0])
//+------------------------------------------------------------------+
   return(rates_total);
  }//int OnCalculate
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+ 
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
/*+------------------------------------------------------------------+ 
          
  :*/
      if(lparam>=coordinateX0 && lparam<=coordinateX1 &&
         dparam>=coordinateY0 && dparam<=coordinateY1)
        {
         string clickedChartObject=sparam;
/*           :*/
         if(StringCompare(clickedChartObject,nameObjBut0,true)==0)
           {
            bool stateBut=ObjectGetInteger(0,clickedChartObject,OBJPROP_STATE);
/*      :*/
            if(stateBut==true)
              {
/*    ,    ,   "",  
     -  (  
  " "):*/
               ObjectsDeleteAll(0,prefixObj,0,EMPTY);
/* ,        ,  
    "" :*/
               switchButtonClick=3;
/*    "" :*/
               SetButtonMin(switchButtonClick,nameObjBut1,xDistance+heightObj,
                            yDistance,heightObj,heightObj);

               ChartRedraw();
               return;
              }//if(stateBut==true)
           }//if(StringCompare(clickedChartObject,nameObjBut0,true)==0)
/*+------------------------------------------------------------------+                  
,      "" :*/
         else if(StringCompare(clickedChartObject,nameObjBut1,true)==0)
           {
            bool stateBut=ObjectGetInteger(0,clickedChartObject,OBJPROP_STATE);
            if(stateBut==true)
              {
               ObjDelete(0,nameObjBut1);//  "" 
               TableCreate();//   

               ChartRedraw();
               return;
              }
           }//if(StringCompare(clickedChartObject,nameObjBut1,true)==0)
         else return;
        }//lparam/dparam
      else return;
     }//  if(id==CHARTEVENT_OBJECT_CLICK)
//+------------------------------------------------------------------+
//|           |
//|                                                     |
//+------------------------------------------------------------------+ 
   else if(id==CHARTEVENT_CHART_CHANGE)
     {
      int ch=ChartWidthInPixels();
/*   ,    
 :*/
      if(chartWidthK!=ch)
        {
         chartWidthK=ch;
         switch(switchButtonClick)
           {
            case 1:GetClickCoordinateObj(nameObjBut0); break;
            case 3:GetClickCoordinateObj(nameObjBut1);break;
            default: break;
           }
         return;
        }
      else return;
     }
   return;
  }
//+------------------------------------------------------------------+
//|       OnInit:           |
//+------------------------------------------------------------------+
bool SetOnInitAny()
  {
/*+------------------------------------------------------------------+
     X <  > :*/
   if(ARRAY_SIZE_X<2 || ARRAY_SIZE_X>30)
     {
      Print(LINE_NUMBER,"Error code: ARRAY_SIZE_X.");
      return(false);
     }
/*+------------------------------------------------------------------+
        ,   
   840,     , 
   840- .     - 
     :*/
   if(TerminalInfoInteger(TERMINAL_BUILD)<840)
     {
      Alert("Indicator removed. The client terminal build number < 840.");
      return(false);
     }
//+------------------------------------------------------------------+
/*     :*/
   if(!CheckInput(ma_period1,"Period Moving Averages (1)"))return(false);
   if(!CheckInput(ma_period2,"Period Moving Averages (2)"))return(false);
/*+------------------------------------------------------------------+
    <1,    = 1:*/
   shiftK=(shift<1)?1:shiftK=shift;
//+------------------------------------------------------------------+
   timeframe1=PERIOD_CURRENT;
/*          
 :*/
   int minP1=ma_period1+ARRAY_SIZE_X+shiftK+5;
   int minP2=ma_period2+ARRAY_SIZE_X+shiftK+5;

/*    ,    
:*/
   minBars=MathMax(minP1,minP2);
//+------------------------------------------------------------------+
/*       
 iMA   :*/
   switchMA1=-1;switchMA2=-1;
   SetOnInitSwitchMA(switchMA1,ma_period1,ma_method1,applied_price1);
   SetOnInitSwitchMA(switchMA2,ma_period2,ma_method2,applied_price2);
//+------------------------------------------------------------------+
   dig=(digCh==auto)?Digits():digCh;//  
/*+------------------------------------------------------------------+
         :*/
   pointK=MathPow(10,dig);
/*+------------------------------------------------------------------+
        / ,  
  0:*/
   SetInputIndent(indent1,indentK1);
   SetInputIndent(indent2,indentK2);
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|   ,           |
//|     iMA   :           |
//+------------------------------------------------------------------+
int SetOnInitSwitchMA(int &switch_MA,
                      const int ma_period,
                      const ENUM_MA_METHOD ma_method,
                      const ENUM_APPLIED_PRICE applied_price)
  {
   if(ma_period==1 && ma_method==MODE_SMA && (applied_price==PRICE_CLOSE || 
      applied_price==PRICE_OPEN ||applied_price==PRICE_HIGH ||
      applied_price==PRICE_LOW))
     {
/*    ,       1
    ,   iMA:*/
      switch_MA=0;
     }
   else {switch_MA=1;}//,  iMA
//---
   return(switch_MA);
  }
//+------------------------------------------------------------------+
//|       OnInit:              |
//+------------------------------------------------------------------+
void SetOnInitTable()
  {
//+------------------------------------------------------------------+
   switchButtonClick=-1;chartWidthK=-1;
/*+------------------------------------------------------------------+
            
 */
   for(int y=0;y<COUNT_BUFFERS+1;y++)
             for(int x=0;x<ARRAY_SIZE_X;x++){backClrObjOddY[y][x]=backClrMain;}
/*+------------------------------------------------------------------+
   :*/
   NameObjTwoDArray(ARRAY_SIZE_Y,nameObj,"Edit");
   nameObjBut0=StringConcatenate(prefixObj,"B0");
   nameObjBut1=StringConcatenate(prefixObj,"B1");
//+------------------------------------------------------------------+
   TableCreate();//   
//+------------------------------------------------------------------+
   return;
  }
//+------------------------------------------------------------------+
//|   ,                |
//+------------------------------------------------------------------+
void SetButtonMin(int flag,string name,int x,int y,int width,int height)
  {
   switch(flag)
     {
      case 1:   if(ObjectFind(0,name)<0)
         ButtonCreate(0,name,0,x,y,width,height,
                      CORNER_RIGHT_UPPER,"","\n",
                      "Arial",0,
                      backClrMain,backClrMain,clrNONE,false);
      break;

      case 3:
         if(ObjectFind(0,name)<0)
         ButtonCreate(0,name,0,x,y,width,height,
                      CORNER_RIGHT_UPPER,CharToString(229),"ID Lite Info MA",
                      "Wingdings",fontSize+1,
                      clrBlack,backClrMain,clrNONE,false);
         break;
      default:break;
     }
/*+------------------------------------------------------------------+
   ""  "" ,
    ,       
 ""  "" :*/
   ChartWidthInPixels();
   GetClickCoordinateObj(name);
//---
   return;
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool ObjDelete(long chart_ID,string name)
  {
   if(ObjectFind(chart_ID,name)>-1){ObjectDelete(chart_ID,name);}
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|   :                             |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
void TableCreate()
  {
   string toolTipM1=NULL,toolTipM2=NULL,toolTip="Number of bar";

   int xDis=widthObj+DISTANCE_XY,
/*        ,
   :*/
   heightObjMin=(heightObj/3)*2,
/*        
    , ,  
      :*/
   font=fontSize-1;
//+------------------------------------------------------------------+
//| :                                                |
//+------------------------------------------------------------------+
   for(int x=0;x<ARRAY_SIZE_X;x++)
     {
      if(ObjectFind(0,nameObj[0][x])<0)
        {
         EditCreate(0,nameObj[0][x],0,xDistance+xDis*(x+DISTANCE_XY),
                    yDistance,widthObj,heightObjMin,IntegerToString(shiftK+x),
                    toolTip,"Arial",font,ALIGN_CENTER,true,CORNER_RIGHT_UPPER,
                    textClrDelta,backClrMain,clrSnow,backObj);
        }
     }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
   int xDisBut=(xDis*ARRAY_SIZE_X),
   yDis=yDistance+heightObjMin+DISTANCE_XY,
   widthBut=(widthObj)*(ARRAY_SIZE_X),
   heightBut=(heightObj/3)-1;
/* ,        ,
      "" :*/
   switchButtonClick=1;
/*  "" :"*/
   SetButtonMin(switchButtonClick,nameObjBut0,xDisBut,yDis,widthBut,heightBut);
//+------------------------------------------------------------------+
//|          :          |
//+------------------------------------------------------------------+
   int k=COUNT_BUFFERS-1,
   y=COUNT_BUFFERS-1,
   heightObjK=heightObj,
   yDisK=0;
   yDis=coordinateY1+DISTANCE_XY;

/*    :*/
   toolTipM1=SetToolTipMA(toolTipM1,1,timeframe1,ma_period1,ma_method1,
                          applied_price1);
   toolTipM2=SetToolTipMA(toolTipM2,2,timeframe1,ma_period2,ma_method2,
                          applied_price2);

   do//while(y<ARRAY_SIZE_Y && !IsStopped())
     {
      yDisK=yDis+((heightObjK+heightObjMin)*(y-k))+((DISTANCE_XY*COUNT_BUFFERS)*(y-k));
      switch(y)
        {
         case 1:toolTip=toolTipM1;break;
         case 3:toolTip=toolTipM2;break;
         case 5:toolTip="MA1 - MA2";heightObjK=heightObjMin;break;
        }

      for(int x=0;x<ARRAY_SIZE_X;x++)
        {
         if(ObjectFind(0,nameObj[y][x])<0)
           {
            EditCreate(0,nameObj[y][x],0,xDistance+xDis*(x+DISTANCE_XY),
                       yDisK,widthObj,heightObjK,textObjOddY[y-k][x],toolTip,
                       "Arial",fontSize,ALIGN_RIGHT,true,CORNER_RIGHT_UPPER,
                       textClrMA,backClrObjOddY[y-k][x],clrSnow,backObj);
           }
        }
      y=y+COUNT_BUFFERS;
      k=k+1;
     }
   while(y<ARRAY_SIZE_Y && !IsStopped());
//+------------------------------------------------------------------+
//|                       |
//|  :                                  |
//+------------------------------------------------------------------+
   k=COUNT_BUFFERS;
   y=COUNT_BUFFERS;
   yDis=yDis+(heightObj+DISTANCE_XY);
   int widthObjD=(widthObj/3)*2;

   do//while(y<ARRAY_SIZE_Y && !IsStopped())
     {
      toolTip=(y==COUNT_BUFFERS)?toolTip=toolTipM1:toolTipM2;
      yDisK=yDis+((heightObj+heightObjMin)*(y-k))+((DISTANCE_XY*COUNT_BUFFERS)*(y-k));
      for(int x=0;x<ARRAY_SIZE_X;x++)
        {
         if(ObjectFind(0,nameObj[y][x])<0)
           {
            EditCreate(0,nameObj[y][x],0,xDistance+xDis*(x+DISTANCE_XY),
                       yDisK,widthObjD,heightObjMin,textObjEvenY[y-k][x],toolTip,
                       "Arial",font,ALIGN_CENTER,true,CORNER_RIGHT_UPPER,
                       textClrObjEvenY[y-k][x],backClrMain,clrSnow,backObj);
           }
        }
      y=y+COUNT_BUFFERS;
      k=k+1;
     }
   while(y<ARRAY_SIZE_Y && !IsStopped());
//---
   return;
  }
//+------------------------------------------------------------------+
//|       .             |
//|  :                                                  |
//|  MQL4  /  ,           |
//|   /   /          |
//|  :   LINE_NUMBER                     |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|                           |
//| (CHARTEVENT_OBJECT_CLICK).                                       |
//|  : OBJ_LABEL (read-only), OBJ_BUTTON, OBJ_BITMAP,     |
//| OBJ_BITMAP_LABEL, OBJ_EDIT, OBJ_RECTANGLE_LABEL.                 |
//+------------------------------------------------------------------+                
//| ( OBJPROP_CORNER: ENUM_BASE_CORNER = CORNER_RIGHT_UPPER)      |
//+------------------------------------------------------------------+
void GetClickCoordinateObj(string name)
  {
   int x1=(int)ObjectGetInteger(0,name,OBJPROP_XDISTANCE);
   int w1=(int)ObjectGetInteger(0,name,OBJPROP_XSIZE);

   coordinateX0=chartWidthK-x1;//>lparam (   X )
   coordinateX1=coordinateX0+w1;//<lparam (   X )

   int h1=(int)ObjectGetInteger(0,name,OBJPROP_YSIZE);
/*dparam (   Y ):*/
   coordinateY0=(int)ObjectGetInteger(0,name,OBJPROP_YDISTANCE);//> dparam
/*dparam (   Y ):*/
   coordinateY1=coordinateY0+h1;//< dparam
//---
   return;
  }
//+------------------------------------------------------------------+
//|-,    = MODE_SMA +         |
//|Period Moving Averages = 1 +                                      |
//|applied_price = PRICE_CLOSE/PRICE_OPEN/PRICE_HIGH/PRICE_LOW:      |
//+------------------------------------------------------------------+
void PriceSwitchForBuffer(double &buffer[],
                          ENUM_APPLIED_PRICE applied_price,
                          double indent,int limit)
  {
   switch(applied_price)
     {
      case PRICE_CLOSE:CopyCloseBuffer(buffer,indent,limit);
      break;
      case PRICE_OPEN:CopyOpenBuffer(buffer,indent,limit);
      break;
      case PRICE_HIGH:CopyHighBuffer(buffer,indent,limit);
      break;
      case PRICE_LOW:CopyLowBuffer(buffer,indent,limit);
      break;
      default:break;
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CopyCloseBuffer(double &buffer[],double indent,int limit)
  {
   double dt[];
   ArrayResize(dt,limit,limit+1);
   ArraySetAsSeries(dt,true);

   int copied=CopyClose(symb,timeframe1,0,limit,dt);
   if(copied<limit)
     {
      Print(LINE_NUMBER,"Failed to copy close values. Error code = ",GetLastError());
      return(-1);
     }
   else
     {
      for(int i=limit-1;i>=shiftK;i--)
        {
         buffer[i]=NormalizeDouble(dt[i]+indent,dig);
        }
     }
//---
   return(copied);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CopyOpenBuffer(double &buffer[],double indent,int limit)
  {
   double dt[];
   ArrayResize(dt,limit,limit+1);
   ArraySetAsSeries(dt,true);

   int copied=CopyOpen(symb,timeframe1,0,limit,dt);
   if(copied<limit)
     {
      Print(LINE_NUMBER,"Failed to copy open values. Error code = ",GetLastError());
      return(-1);
     }
   else
     {
      for(int i=limit-1;i>=shiftK;i--)
        {
         buffer[i]=NormalizeDouble(dt[i]+indent,dig);
        }
     }
//---
   return(copied);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CopyHighBuffer(double &buffer[],double indent,int limit)
  {
   double dt[];
   ArrayResize(dt,limit,limit+1);
   ArraySetAsSeries(dt,true);

   int copied=CopyHigh(symb,timeframe1,0,limit,dt);
   if(copied<limit)
     {
      Print(LINE_NUMBER,"Failed to copy high values. Error code = ",GetLastError());
      return(-1);
     }
   else
     {
      for(int i=limit-1;i>=shiftK;i--)
        {
         buffer[i]=NormalizeDouble(dt[i]+indent,dig);
        }
     }
//---
   return(copied);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CopyLowBuffer(double &buffer[],double indent,int limit)
  {
   double dt[];
   ArrayResize(dt,limit,limit+1);
   ArraySetAsSeries(dt,true);

   int copied=CopyLow(symb,timeframe1,0,limit,dt);
   if(copied<limit)
     {
      Print(LINE_NUMBER,"Failed to copy low values. Error code = ",GetLastError());
      return(-1);
     }
   else
     {
      for(int i=limit-1;i>=shiftK;i--)
        {
         buffer[i]=NormalizeDouble(dt[i]+indent,dig);
        }
     }
//---
   return(copied);
  }
//+------------------------------------------------------------------+
//|  Moving Averages  iMA:                     |
//+------------------------------------------------------------------+
void PriceIMAforBuffer0(double &buffer[],int ma_period,
                        ENUM_MA_METHOD ma_method,
                        ENUM_APPLIED_PRICE applied_price,
                        double indent,int limit)
  {
   for(int i=limit-1;i>=shiftK;i--)
     {
      buffer[i]=NormalizeDouble(iMA(NULL,timeframe1,
                                ma_period,0,ma_method,
                                applied_price,i)+indent,
                                dig);
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|         .      |
//|      ,   -         |
//|      .                | 
//+------------------------------------------------------------------+
void ChangeValuesTable0(const int y_name,//      Y 
                        const double &buffers[],//  
                        int index,//   &buffers[]
                        int newValues,//    
                        bool &changeClr[],
                        color &clr,//   
                        //   
                        long chart_ID=0)
  {
   int copyOld=0;
   double deltaK[ARRAY_SIZE_X];
/*+------------------------------------------------------------------+
         
,         
,         :*/
   copyOld=ARRAY_SIZE_X-newValues;

   if(copyOld>0)//     
     {
      for(int i=ARRAY_SIZE_X-1;i>=newValues; i--)
        {
         if(StringCompare(textObjOddY[index][i],textObjOddY[index][i-1],true)!=0)
            textObjOddY[index][i]=textObjOddY[index][i-1];
        }
      for(int i=ARRAY_SIZE_X-1;i>=newValues; i--)
        {
         if(backClrObjOddY[index][i]!=backClrObjOddY[index][i-1])
           {
            backClrObjOddY[index][i]=backClrObjOddY[index][i-1];
            textClrObjEvenY[index][i]=textClrObjEvenY[index][i-1];
            changeClr[i]=true;
           }
         else {if(changeClr[i])changeClr[i]=false;}
        }
      for(int i=ARRAY_SIZE_X-1;i>=newValues; i--)
        {
         if(StringCompare(textObjEvenY[index][i],textObjEvenY[index][i-1],true)!=0)
            textObjEvenY[index][i]=textObjEvenY[index][i-1];
        }
     }
/*+------------------------------------------------------------------+
           :*/
   for(int i=newValues-1;i>=0; i--)//    
     {
      textObjOddY[index][i]=DoubleToString(buffers[i+shiftK],dig);
     }
//+------------------------------------------------------------------+
   for(int i=newValues-1;i>=0;i--)//    
     {
      deltaK[i]=NormalizeDouble((buffers[i+shiftK]-buffers[i+shiftK+1])*pointK,0);
      textObjEvenY[index][i]=DoubleToString(deltaK[i],0);
     }
//+------------------------------------------------------------------+
/*     :*/
   ChangeColor(index,newValues,deltaK,backClrObjOddY,textClrObjEvenY,
               changeClr,0);
/*+------------------------------------------------------------------+
,         , 
,  ,      
   :*/
   if(switchButtonClick==1)//      
     {
      for(int i=ARRAY_SIZE_X-1;i>=0;i--)
        {
/*       :*/
         if(ObjectFind(0,nameObj[y_name][i])>-1)
           {
/*     ,     
:*/
            string text=ObjectGetString(chart_ID,nameObj[y_name][i],OBJPROP_TEXT);
            if(StringCompare(text,textObjOddY[index][i],true)!=0)
              {
               ObjSetString(0,nameObj[y_name][i],OBJPROP_TEXT,textObjOddY[index][i]);
              }
/*,            ,
      :*/
            if(changeClr[i]==true)
              {
               ObjSetIntegerColor(0,nameObj[y_name][i],OBJPROP_BGCOLOR,backClrObjOddY[index][i]);
               changeClr[i]=false;
              }
           }
        }
/*+---------------------------------------------------------------------------+
,  ,        
:*/
      for(int i=ARRAY_SIZE_X-1;i>=0;i--)
        {
/*      :*/
         if(ObjectFind(0,nameObj[y_name+1][i])>-1)
           {
/*       ,   
  :*/
            string text=ObjectGetString(chart_ID,nameObj[y_name+1][i],OBJPROP_TEXT);
            if(StringCompare(text,textObjEvenY[index][i],true)!=0)
              {
               ObjSetString(0,nameObj[y_name+1][i],OBJPROP_TEXT,textObjEvenY[index][i]);
              }
/*,          ,
     :*/
            if(changeClr[i]==true)
              {
               ObjSetIntegerColor(0,nameObj[y_name+1][i],OBJPROP_COLOR,textClrObjEvenY[index][i]);
              }
           }
        }
     }// if(switchButtonClick==1)
/*+------------------------------------------------------------------+
   ,      
   (     
     ):*/
   if(showLine)//       
     {
      if(clr!=textClrObjEvenY[index][0])
        {
         clr=textClrObjEvenY[index][0];
         SetIndexStyle(index,DRAW_LINE,EMPTY,EMPTY,clr);
        }
     }
//+------------------------------------------------------------------+
   return;
  }
//+------------------------------------------------------------------+
//|               |
//|     (   ,           |
//| ).                                                  |
//|      ,   -         |
//|      .                | 
//+------------------------------------------------------------------+
void ChangeValuesTable1(const int y_name,//   Y   
                        const double &buffers0[],//    
                        const double &buffers1[],//    
                        int y_text,//      Y 
                        int newValues,//    
                        long chart_ID=0)
  {
   int copyOld=0;
/*+------------------------------------------------------------------+
         
,         
,      :*/
   copyOld=ARRAY_SIZE_X-newValues;
   if(copyOld>0)//     
     {
      for(int i=ARRAY_SIZE_X-1;i>=newValues; i--)
        {
         if(StringCompare(textObjOddY[y_text][i],textObjOddY[y_text][i-1],true)!=0)
            textObjOddY[y_text][i]=textObjOddY[y_text][i-1];
        }
     }
/*+------------------------------------------------------------------+
           :*/
   for(int i=newValues-1;i>=0; i--)//    
     {
      double valueDelta=MathAbs((buffers0[i+shiftK]-buffers1[i+shiftK])*pointK);
      textObjOddY[y_text][i]=DoubleToString(valueDelta,0);
     }

/*+------------------------------------------------------------------+
,       , ,  
,         :*/
   if(switchButtonClick==1)//      
     {
      for(int i=ARRAY_SIZE_X-1;i>=0;i--)
        {
/*       :*/
         if(ObjectFind(0,nameObj[y_name][i])>-1)
           {
/*      ,    
    :*/
            string text=ObjectGetString(chart_ID,nameObj[y_name][i],OBJPROP_TEXT);
            if(StringCompare(text,textObjOddY[y_text][i],true)!=0)
              {
               ObjSetString(0,nameObj[y_name][i],OBJPROP_TEXT,textObjOddY[y_text][i]);
              }
           }
        }
     }
//+------------------------------------------------------------------+
   return;
  }
//+------------------------------------------------------------------+
//|           |
//|    (3000 -          |
//|        ):       |
//+------------------------------------------------------------------+
bool CheckInput(int period,string text)
  {
   string t=NULL;
   if(period<1 || period>3000)
     {
      t=StringConcatenate("Indicator removed. ",text,": < 1 or > 3000.");
      Alert(t);
      return(false);
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|       int         | 
//|double:                                                           |
//+------------------------------------------------------------------+
double SetInputIndent(const int indent,//  ,    
                      double &indentK)// ,     

  {
   int p=(int)(100*pointK);//      
   int ind0=(int)MathAbs(indent);
/*+------------------------------------------------------------------+
           / ,
   0:*/
   indentK=(ind0==0 || ind0>=p)?0.0:indent*Point();
//+------------------------------------------------------------------+
   return(indentK);
  }
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
void NameObjTwoDArray(int countY,//    Y
                      string &array[][ARRAY_SIZE_X],//   
                      string dt="_")//-)
  {
   string text=NULL;
   for(int y=0;y<countY;y++)
      for(int x=0;x<ARRAY_SIZE_X;x++)
        {
         text=StringConcatenate(prefixObj,dt,IntegerToString(y),
                                IntegerToString(x));
         array[y][x]=text;
        }
//---
   return;
  }
//+------------------------------------------------------------------+
//|  .                                           |
//|    :                                   |
//| MQL5  /  ,            |
//|  /    /   / OBJ_BUTTON     |
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,               // ID 
                  const string            name="Button",            //  
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X
                  const int               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                  const string            text="Button",            // 
                  const string            toolTip="\n",             //   
                  const string            font="Arial",             // 
                  const int               font_size=10,             //  
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const bool              state=false,              // /
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0,                //    
                  const int               timeframes=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---  
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create the button! Error code = ",GetLastError());
      return(false);
     }
   ObjSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);//      X    
   ObjSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);//      Y    
   ObjSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);//     X  .
   ObjSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);//     Y  .
   ObjSetIntegerCorner(chart_ID,name,corner);//       
   ObjSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);//   
   ObjSetString(chart_ID,name,OBJPROP_TEXT,text);//   (,   ) 
   ObjSetString(chart_ID,name,OBJPROP_FONT,font);// 
   ObjSetIntegerInt(chart_ID,name,OBJPROP_FONTSIZE,font_size);//  
   ObjSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);//    (   ..)
   ObjSetIntegerColor(chart_ID,name,OBJPROP_BGCOLOR,back_clr);//   OBJ_EDIT, OBJ_BUTTON, OBJ_RECTANGLE_LABEL 
   ObjSetIntegerColor(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);//     OBJ_EDIT  OBJ_BUTTON
   ObjSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);//    (true)    (false)
   ObjSetIntegerBool(chart_ID,name,OBJPROP_STATE,state);//OBJPROP_STATE    ( = true/ = false 
   ObjSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);//  (true)   (false)
   ObjSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);//  (true)   (false)      
   ObjSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);//    
   ObjSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeframes);//     .
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|   " ".                              |
//|    :                                   |
//| MQL5 /  ,             |
//| /   /   / OBJ_EDIT         |  
//+------------------------------------------------------------------+
bool EditCreate(const long             chart_ID=0,               // ID 
                const string           name="Edit",              //  
                const int              sub_window=0,             //  
                const int              x=0,                      //    X
                const int              y=0,                      //    Y
                const int              width=50,                 // 
                const int              height=20,                // 
                const string           text="Text",              // 
                const string           toolTip="\n",             //   
                const string           font="Arial",             // 
                const int              font_size=9,              //  
                const ENUM_ALIGN_MODE  align=ALIGN_CENTER,       //  
                const bool             read_only=false,          //  
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                const color            clr=clrBlack,             //  
                const color            back_clr=clrWhite,        //  
                const color            border_clr=clrNONE,       //  
                const bool             back=false,               //   
                const bool             selection=false,          //   
                const bool             hidden=true,              //    
                const long             z_order=0,                //    
                const int             timeframes=OBJ_ALL_PERIODS)//    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0))
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ": failed to create \"Edit\" object! Error code = ",GetLastError());
      return(false);
     }
   ObjSetIntegerInt(chart_ID,name,OBJPROP_XDISTANCE,x);//      X   
   ObjSetIntegerInt(chart_ID,name,OBJPROP_YDISTANCE,y);//      Y    
   ObjSetIntegerInt(chart_ID,name,OBJPROP_XSIZE,width);//     X  .
   ObjSetIntegerInt(chart_ID,name,OBJPROP_YSIZE,height);//     Y  .
   ObjSetString(chart_ID,name,OBJPROP_TOOLTIP,toolTip);//    
   ObjSetString(chart_ID,name,OBJPROP_TEXT,text);//   (,   )
   ObjSetString(chart_ID,name,OBJPROP_FONT,font);// 
   ObjSetIntegerInt(chart_ID,name,OBJPROP_FONTSIZE,font_size);//  
   ObjSetIntegerAlign(chart_ID,name,align);//      " " (OBJ_EDIT)
   ObjSetIntegerBool(chart_ID,name,OBJPROP_READONLY,read_only);//  (true)/(false)    
   ObjSetIntegerCorner(chart_ID,name,corner);//       
   ObjSetIntegerColor(chart_ID,name,OBJPROP_COLOR,clr);//    (   ..)
   ObjSetIntegerColor(chart_ID,name,OBJPROP_BGCOLOR,back_clr);//   OBJ_EDIT, OBJ_BUTTON, OBJ_RECTANGLE_LABEL 
   ObjSetIntegerColor(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);//     OBJ_EDIT  OBJ_BUTTON
   ObjSetIntegerBool(chart_ID,name,OBJPROP_BACK,back);//    (true)    (false)
   ObjSetIntegerBool(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjSetIntegerBool(chart_ID,name,OBJPROP_SELECTED,selection);//  (true)   (false)
   ObjSetIntegerBool(chart_ID,name,OBJPROP_HIDDEN,hidden);//  (true)   (false)      
   ObjSetIntegerLong(chart_ID,name,OBJPROP_ZORDER,z_order);//    
   ObjSetIntegerInt(chart_ID,name,OBJPROP_TIMEFRAMES,timeframes);//     
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|              | 
//|                                                     |
//+------------------------------------------------------------------+
string SetToolTipMA(string &name,int n,ENUM_TIMEFRAMES timeframe,
                    int ma_period,ENUM_MA_METHOD ma_method,
                    ENUM_APPLIED_PRICE applied_price)
  {
   name=StringConcatenate("MA ",n,": ",EnumToString(timeframe),
                          ",\r\nma_period: ",ma_period,",\r\n",EnumToString(ma_method),
                          ",\r\n",EnumToString(applied_price),",\r\nshift: ",shiftK);
//---
   return(name);
  }
//+------------------------------------------------------------------+
//|     ,        |
//|(      ):                    |  
//+------------------------------------------------------------------+
void ChangeColor(int y,//    Y
                 int newValues,//     X   
                 double &price[ARRAY_SIZE_X],//     
                 color &back_clr[][ARRAY_SIZE_X],//  
                 color &clr[][ARRAY_SIZE_X],// 
                 bool &changeClr[],
                 const int digits)
  {
   color color1=0,color2=0;

   for(int x=newValues-1;x>=0;x--)//     
     {
      if(NormalizeDouble(price[x],digits)>0)
        {color1=color2=backClrUp;} // price[1]>price[2]
      else if(NormalizeDouble(price[x],digits)<0)
        {color1=color2=backClrDown;} // price[1]<price[2]
      else if(NormalizeDouble(price[x],digits)==0)
        {color1=backClrMain;color2=textClrDelta;} //price[1]=price[2]      
      //---
      if(back_clr[y][x]!=color1)
        {
         back_clr[y][x]=color1;
         clr[y][x]=color2;
         changeClr[x]=true;
        }
      else{changeClr[x]=false;}
     }
//---
   return;
  }//void ChangeColor
//+------------------------------------------------------------------+
//|ObjectSetString (  ,   )
//+------------------------------------------------------------------+
//|ENUM_OBJECT_PROPERTY_STRING:
//+------------------------------------------------------------------+
//|OBJPROP_NAME -   - string;
//+------------------------------------------------------------------+
//|OBJPROP_TEXT -   (,   )- string;
//+------------------------------------------------------------------+
//|OBJPROP_TOOLTIP -   .    ,
//|  ,   .
//|    ,     "\n" ( )- string;
//+------------------------------------------------------------------+
//|OBJPROP_LEVELTEXT -   - string    = ;
//+------------------------------------------------------------------+
//|OBJPROP_FONT -  - string;
//+------------------------------------------------------------------+
//|OBJPROP_BMPFILE -  BMP-   " ". .   - string
//|: 0- ON, 1- OFF;
//+------------------------------------------------------------------+
//|OBJPROP_SYMBOL    "" - string.
//+------------------------------------------------------------------+
bool ObjSetString(long chart_ID,string name,ENUM_OBJECT_PROPERTY_STRING pr,string font)
  {
   ResetLastError();
//---
   if(!ObjectSetString(chart_ID,name,pr,font))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|ObjectSetIntegerColor (  ,   )
//|ENUM_OBJECT_PROPERTY_INTEGER:
//+------------------------------------------------------------------+
//|OBJPROP_COLOR -  (       ,
//|   ..) - color;
//+------------------------------------------------------------------+
//|OBJPROP_LEVELCOLOR -  - - color = ;
//+------------------------------------------------------------------+
//|OBJPROP_BGCOLOR -    OBJ_EDIT, OBJ_BUTTON, OBJ_RECTANGLE_LABEL - color;
//+------------------------------------------------------------------+
//|OBJPROP_BORDER_COLOR -     OBJ_EDIT  OBJ_BUTTON - color;
//+------------------------------------------------------------------+
bool ObjSetIntegerColor(long chart_ID,string name,ENUM_OBJECT_PROPERTY_INTEGER pr,color dt)
  {
   ResetLastError();
//---
   if(!ObjectSetInteger(chart_ID,name,pr,dt))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|ObjectSetIntegerInt (  ,   )
//|ENUM_OBJECT_PROPERTY_INTEGER:
//+------------------------------------------------------------------+
//|OBJPROP_WIDTH -   - int;
//+------------------------------------------------------------------+
//|OBJPROP_LEVELS -   - int;
//+------------------------------------------------------------------+
//|OBJPROP_LEVELWIDTH -  - - int = ;
//+------------------------------------------------------------------+
//|OBJPROP_FONTSIZE -   - int;
//+------------------------------------------------------------------+
//|OBJPROP_TIMEFRAMES -     -   flags;int
//+------------------------------------------------------------------+
//|OBJPROP_XDISTANCE -      X   
//| (. ) - int;
//+------------------------------------------------------------------+
//|OBJPROP_YDISTANCE -      Y  
//| (. ) - int;
//+------------------------------------------------------------------+
//|OBJPROP_XSIZE -     X  .  
//| OBJ_LABEL (read only), OBJ_BUTTON, OBJ_CHART, OBJ_BITMAP,
//|OBJ_BITMAP_LABEL, OBJ_EDIT, OBJ_RECTANGLE_LABEL. - int;
//+------------------------------------------------------------------+
//|OBJPROP_YSIZE -     Y  .   
//| OBJ_LABEL (read only), OBJ_BUTTON, OBJ_CHART, OBJ_BITMAP,
//|OBJ_BITMAP_LABEL, OBJ_EDIT, OBJ_RECTANGLE_LABEL. - int;
//+------------------------------------------------------------------+
//|OBJPROP_XOFFSET - X-     
//|     " " 
//|"" (OBJ_BITMAP_LABEL  OBJ_BITMAP).    
//|     . - int;
//+------------------------------------------------------------------+
//|OBJPROP_YOFFSET - Y-     
//|     " " 
//|"" (OBJ_BITMAP_LABEL  OBJ_BITMAP).    
//|     . - int;
//+------------------------------------------------------------------+
//|OBJPROP_CHART_SCALE -    "" - int      05
//+------------------------------------------------------------------+
bool ObjSetIntegerInt(long chart_ID,string name,ENUM_OBJECT_PROPERTY_INTEGER pr,int dt)
  {
   ResetLastError();
//---
   if(!ObjectSetInteger(chart_ID,name,pr,dt))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|      
//+------------------------------------------------------------------+
//|OBJPROP_CORNER -       - ENUM_BASE_CORNER;
//+------------------------------------------------------------------+
bool ObjSetIntegerCorner(long chart_ID,string name,ENUM_BASE_CORNER corner)
  {
   ResetLastError();
//---
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|ObjectSetIntegerBool (  ,   )
//|ENUM_OBJECT_PROPERTY_INTEGER:
//+------------------------------------------------------------------+
//|OBJPROP_BACK -     - bool;
//+------------------------------------------------------------------+
//|OBJPROP_FILL    ( OBJ_RECTANGLE, OBJ_TRIANGLE,
//|OBJ_ELLIPSE, OBJ_CHANNEL, OBJ_STDDEVCHANNEL, OBJ_REGRESSION) - bool;
//+------------------------------------------------------------------+
//|OBJPROP_HIDDEN -        
//|    "" - "" - " ".
//| true        . 
//|  true   ,   
//|,  ,      MQL5-.
//|           
//|,    ""   " ". - bool
//+------------------------------------------------------------------+
//|OBJPROP_SELECTED -   - bool;
//+------------------------------------------------------------------+
//|OBJPROP_READONLY -      Edit - bool;
//+------------------------------------------------------------------+
//|OBJPROP_SELECTABLE -   - bool;
//+------------------------------------------------------------------+
//|OBJPROP_RAY_LEFT -    - bool;
//+------------------------------------------------------------------+
//|OBJPROP_RAY_RIGHT -    - bool;
//+------------------------------------------------------------------+
//|OBJPROP_RAY -        - bool;
//+------------------------------------------------------------------+
//|OBJPROP_ELLIPSE -      
//|" " (OBJ_FIBOARC) - bool;
//+------------------------------------------------------------------+
//|OBJPROP_DRAWLINES -       - bool;
//+------------------------------------------------------------------+
//|OBJPROP_STATE -   (/) - bool;
//+------------------------------------------------------------------+
//|OBJPROP_DATE_SCALE -       "" - bool;
//+------------------------------------------------------------------+
//|OBJPROP_PRICE_SCALE -       "" - bool;
//+------------------------------------------------------------------+
bool ObjSetIntegerBool(long chart_ID,string name,ENUM_OBJECT_PROPERTY_INTEGER pr,bool dt)
  {
   ResetLastError();
//---
   if(!ObjectSetInteger(chart_ID,name,pr,dt))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|ObjectSetIntegerLong (  ,   )
//|ENUM_OBJECT_PROPERTY_INTEGER:
//+------------------------------------------------------------------+
//|OBJPROP_ZORDER -      
//|    (CHARTEVENT_CLICK).    
//|   ,     
//|.        CHARTEVENT_CLICK
//|   ,    . - long;
//+------------------------------------------------------------------+
//|OBJPROP_CHART_ID -   "" (OBJ_CHART).  
//|          
//|     ,    . - long  r/o;
//+------------------------------------------------------------------+
bool ObjSetIntegerLong(long chart_ID,string name,ENUM_OBJECT_PROPERTY_INTEGER pr,long dt)
  {
   ResetLastError();
//---
   if(!ObjectSetInteger(chart_ID,name,pr,dt))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|      " "  
//|(OBJ_EDIT)
//+------------------------------------------------------------------+
//|OBJPROP_ALIGN -      
//|" " (OBJ_EDIT) = ENUM_ALIGN_MODE;
//+------------------------------------------------------------------+
bool ObjSetIntegerAlign(long chart_ID,string name,ENUM_ALIGN_MODE align)
  {
   ResetLastError();
//---
   if(!ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,align))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
