//+------------------------------------------------------------------+
//|                                                ADXVMA_Bemac1.mq4 |                                     
//+------------------------------------------------------------------+
//Revision history; 
//FantailVMA1: Modified version of VarMA_v1.1.mq4 and Fantail.tpl
//FantailVMA1.mq4 is intended to used by adding the template FantailVMA1.tpl to the chart. 10 Sept 2007.
//FantailVMA2 & Fantail2.tpl: Turbo version attempt, 17 Sept 2007. Malfunctioned at live end of chart.
//FantailVMA3 & Fantail3.tpl: Bug fix, work-around added to keep iMAOnArray() from malfunctioning.
//The first yellow ema line MA1 periods=2, was deleted in version 3.
//FantailVMA4 & Fantail4.tpl: Simpler input, bug fix, speed improvement, 3 vma lines, 24 Sept 2007.
//FantailVMA4 & 4Turbo used faulty smoothing that failed on live charts.
//FantailVMA5Turbo, live bar bug fix, user settings added. Still live bar problems.
//ADXVMA5Line1-3 back to using arrays, so its one vma line per indicator.


#property indicator_chart_window
#property indicator_buffers   2
#property indicator_color1    Lime
#property indicator_width1    2 
#property indicator_color2    Lime
#property indicator_width2    2 
//---- input parameters
extern int     ADX_Bars=4;
extern double  WeightDM=5.0;
extern double  WeightDI=5.0;
extern double  WeightDX=5.0;
extern double  VImax=0.4;
extern double  ChandeEMA3=2.0;
extern int     EMA100=100;
//---- buffers
double MA[];
double EMA[];
double PDM[];//Not displayed
double MDM[];//Not displayed
double PDI[];//Not displayed
double MDI[];//Not displayed
double Out[];//Not displayed

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MA);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,EMA);   
   SetIndexBuffer(2,PDM);
   SetIndexBuffer(3,MDM);   
   SetIndexBuffer(4,PDI);
   SetIndexBuffer(5,MDI); 
   SetIndexBuffer(6,Out);
   
   //---- name for DataWindow and indicator subwindow label
   string short_name="ADXVMA_Bemac1";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"ADXVMA_Bemac1");
   SetIndexLabel(1,"ADXVMA_Bemac1");
   //----
   SetIndexDrawBegin(0,4+ADX_Bars);
         
//--------- Safety overrides on user settings
   if (ADX_Bars<1)ADX_Bars=1;
   if (WeightDM<1.0)WeightDM=1.0;
   if (WeightDI<1.0)WeightDI=1.0;
   if (WeightDX<1.0)WeightDX=1.0;      
   if (VImax<0.1)VImax=1.0;
   if (ChandeEMA3<1.0)ChandeEMA3=1.0;
   if (EMA100<2)EMA100=2;
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int   limit, i, j, counted_bars=IndicatorCounted();
   double TH, TL, TR,DI_Diff, DI_Sum, DI_Factor, VI, diff, HHV, LLV; 

//---- 
     
   if (counted_bars<0) return(-1);  //MT4 error exit.

   for(i=Bars-counted_bars-1;i>Bars-4-ADX_Bars;i--) //Needed in MT4 to prevent malfunctions at historical end of chart.
   {
   MA[i]=Close[i]; //Prefill the oldest bars with safe data for the historical averaging.   
   PDM[i]=0;
   MDM[i]=0;
   PDI[i]=0;
   MDI[i]=0;
   Out[i]=0;
   }
   
   for(i=i; i>=0; i--) //Other platforms probably need only BarCount()? 
   {     
   PDM[i]=0;
   MDM[i]=0;
   if(Close[i+1]>High[i])TH=Close[i+1];
   else TH=High[i];
   if(Close[i+1]<Low[i])TL=Close[i+1];
   else TL=Low[i];
   TR=TH-TL;
   if(High[i]>High[i+1] && Low[i]>=Low[i+1])PDM[i]=High[i]-High[i+1];
   else if(High[i]>High[i+1] && Low[i]<Low[i+1] && (High[i+1]-High[i+1])>(Low[i+1]-Low[i]))PDM[i]=High[i]-High[i+1];
   if(Low[i]<Low[i+1] && High[i]>=High[i+1])MDM[i]=Low[i+1]-Low[i];//Always positive
//   else if(High[i]>High[i+1] &&Low[i]<Low[i+1] && (High[i]-High[i+1])<(Low[i+1]-Low[i]))MDM[i]=Low[i+1]-Low[i];
   else if(Low[i]<Low[i+1] && High[i]<High[i+1] && (High[i+1]-High[i+1])<(Low[i+1]-Low[i]))MDM[i]=Low[i+1]-Low[i];
 //  TR=PDM[i]+MDM[i];
 
   PDM[i]=((WeightDM-1)*PDM[i+1] + PDM[i])/WeightDM;//ema.
   MDM[i]=((WeightDM-1)*MDM[i+1] + MDM[i])/WeightDM;//ema.

   if (TR>0) {PDI[i]=PDM[i]/TR; MDI[i]=MDM[i]/TR;}//Avoid division by zero. Minimum step size is one unnormalized price pip.
   else {PDI[i]=0; MDI[i]=0;}
   
   PDI[i]=((WeightDI-1)*PDI[i+1] + PDI[i])/WeightDI;//ema.
   MDI[i]=((WeightDI-1)*MDI[i+1] + MDI[i])/WeightDI;//ema.
   DI_Diff=PDI[i]-MDI[i];  
   if (DI_Diff<0) DI_Diff= -DI_Diff;//Only positive momentum signals are used.
   DI_Sum=PDI[i]+MDI[i];
   DI_Factor=0;//Zero case, DI_Diff will also be zero when DI_Sum is zero.
   if (DI_Sum>0) Out[i]=DI_Diff/DI_Sum;//Factional, near zero when PDM==MDM (horizonal), near 1 for laddering.
   else Out[i]=0;
   Out[i]=((WeightDX-1)*Out[i+1] + Out[i])/WeightDX;
   
   if (Out[i]>Out[i+1]){HHV=Out[i];LLV=Out[i+1];}
   else {HHV=Out[i+1];LLV=Out[i];}
   for(j=0;j<ADX_Bars-1;j++)
   {
   if(Out[i+j+1]>HHV)HHV=Out[i+j+1];
   if(Out[i+j+1]<LLV)LLV=Out[i+j+1];
   }
   
   diff = HHV - LLV;//Veriable reference scale, adapts to recent activity level, unnormalized.
   VI=0;//Zero case. This fixes the output at its historical level. Normalized, 0-1 scale.
   if (diff>0) VI=(Out[i]-LLV)/diff;
   if(VI>VImax)VI=VImax;//Used by Bemac with VImax=0.4, still used in vma1 and affects 5min trend definition.
                        //All the ema weight settings, including Chande, affect 5 min trend definition.
   MA[i]=((ChandeEMA3-VI)*MA[i+1]+VI*Close[i])/ChandeEMA3;//Chande VMA formula with ema built in.
    
   }
   if ( counted_bars ==0 ) limit=Bars-1;
   if(counted_bars>0) limit=Bars-counted_bars;
   limit--;
   for(j=limit; j>=0; j--) EMA[j] = iMAOnArray(MA,0,EMA100,0,1,j);
//----
   return(0);
  }
//+------------------------------------------------------------------+

