
 //+------------------------------------------------------------------+
 //|                                                                  |
 //|                                                                  |
 //|                                                                  |
 //+------------------------------------------------------------------+
   
#property copyright "Renko Ashi Trading 2017"
#property link      "www.Renkoashitrading.com"

#property indicator_chart_window

#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern string info1="Fast Moving Average Settings";
extern int Fast_MaPeriod=1;
extern int Fast_MaMethod=0;
extern int Fast_AppliedPrice=0;
extern string info2="Middle  Moving Average Settings";
extern int Middle_MaPeriod=1;
extern int Middle_MaMethod=0;
extern int Middle_AppliedPrice=1;
extern string info3="Slow Moving Average Settings";
extern int Slow_MaPeriod=5;
extern int Slow_MaMethod=0;
extern int Slow_AppliedPrice=5;
extern bool EnableAlert=true;
extern bool EnableComment=true;

datetime Timee;
datetime Timem;
double Up_Arrow[];
double Dn_Arrow[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,Up_Arrow);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(1,Dn_Arrow);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
 {
  Comment("");
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[]) 
 { 
  if(EnableComment)Comment("RenkoAshiFilter"); 
  
   
   
  int bars=Bars-IndicatorCounted();
  static int LastSignal=0;
  for(int i=bars;i>=1;i--)
  {
   int counter=i;
   double Range=0;
   double AvgRange=0;
   for (counter=i ;counter<=i+9;counter++)
   {
    AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
   }
   Range=AvgRange/10;
   double Ma1=iMA(Symbol(),0,Fast_MaPeriod,0,Fast_MaMethod,Fast_AppliedPrice,i+0);  
   double Ma2=iMA(Symbol(),0,Middle_MaPeriod,0,Middle_MaMethod,Middle_AppliedPrice,i+0); 
   double Ma3=iMA(Symbol(),0,Slow_MaPeriod,0,Slow_MaMethod,Slow_AppliedPrice,i+0); 
  
   if(Ma1>Ma2 && Ma2>Ma3 && LastSignal!=1)
   {
    Up_Arrow[i] = Low[i] - Range*0.5;
    LastSignal=1;
    if(Timee!=Time[0]&&Up_Arrow[1]<5000&&EnableAlert)
    {
     Alert("Moving Average Crossover Up Buy: ",Symbol(),"  TimeFrame: ",Period()+"M");
     Timee=Time[0];
    }     
    
   }
   if(Ma1<Ma2 && Ma2<Ma3 && LastSignal!=-1)
   {
    Dn_Arrow[i] = High[i] + Range*0.5;
    LastSignal=-1;
    if(Timee!=Time[0]&&Dn_Arrow[1]<5000&&EnableAlert)
    {
     Alert("Moving Average Crossover Down Sell: ",Symbol(),"  TimeFrame: ",Period()+"M");
     Timee=Time[0];
    }        
   }     
 }
 }