//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen - mladenfx@gmail.com"
#property link      "www.forex-station.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrSandyBrown
#property indicator_color5  clrSandyBrown
#property indicator_color6  clrDeepSkyBlue
#property indicator_color7  clrSandyBrown
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  1
#property indicator_width7  1
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2, // Heiken ashi trend biased (extreme) price
   pr_habclose,   // Heiken ashi (better formula) close
   pr_habopen ,   // Heiken ashi (better formula) open
   pr_habhigh,    // Heiken ashi (better formula) high
   pr_hablow,     // Heiken ashi (better formula) low
   pr_habmedian,  // Heiken ashi (better formula) median
   pr_habtypical, // Heiken ashi (better formula) typical
   pr_habweighted,// Heiken ashi (better formula) weighted
   pr_habaverage, // Heiken ashi (better formula) average
   pr_habmedianb, // Heiken ashi (better formula) median body
   pr_habtbiased, // Heiken ashi (better formula) trend biased price
   pr_habtbiased2 // Heiken ashi (better formula) trend biased (extreme) price
};

#define _fltPrc 1
#define _fltVal 2
enum enFilterWhat
{
   flt_01=_fltPrc,        // Filter the prices
   flt_02=_fltVal,        // Filter the ema value
   flt_03=_fltPrc+_fltVal // Filter prices and the ema value
};
#define _disLin 1
#define _disHis 2
#define _disDot 4
enum enDisplay
{
   dis_01=_disLin,                // Display line
   dis_02=_disHis,                // Display colored bars
   dis_07=_disDot,                // Display dots
   dis_03=_disLin+_disHis,        // Display colored lines and bars
   dis_04=_disLin+_disDot,        // Display lines with dots
   dis_05=_disHis+_disDot,        // Display colored bars with dots
   dis_06=_disLin+_disDot+_disHis // Display all
};

extern ENUM_TIMEFRAMES    TimeFrame          = PERIOD_CURRENT;  // Time frame to use
extern int                Length             = 14;              // Calculation length
extern enPrices           Price              = pr_close;        // Price to use
extern double             Lambda             = 5;               // Lambda
extern double             Filter             = 0;               // Filter to use for filtering (<=0 - no filtering)
extern int                FilterPeriod       = 0;               // Filter period (0<= use ema period)
extern enFilterWhat       FilterOn           = _fltVal;         // Apply filter to :
extern bool               alertsOn           = false;           // Turn alerts on?
extern bool               alertsOnCurrent    = true;            // Alerts on current (still opened) bar?
extern bool               alertsMessage      = true;            // Alerts should show pop-up message?
extern bool               alertsSound        = false;           // Alerts should play a sound?
extern bool               alertsEmail        = false;           // Alerts should send email?
extern bool               alertsPushNotif    = false;           // Alerts should send push notification?
extern enDisplay          DisplayType        = _disLin;         // Display type
extern int                LinesWidth         = 3;               // Lines width (when lines are included in display)
extern int                BarsWidth          = 1;               // Bars width (when bars are included in display)
extern int                ArrowCodeUp        = 159;             // Arrow code up
extern int                ArrowCodeDn        = 159;             // Arrow code down
extern double             ArrowGapUp         = 0.5;             // Gap for arrow up        
extern double             ArrowGapDn         = 0.5;             // Gap for arrow down
extern bool               Interpolate        = true;            // Interpolate in multi time frame mode

//
//
//
//
//

double mom[],rema[],remda[],remdb[],slope[],histou[],histod[],arrowu[],arrowd[],count[];
string indicatorFileName;
#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Lambda,Filter,FilterPeriod,FilterOn,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsPushNotif,_buff,_ind)

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
      int lstyle = ((DisplayType&_disLin)!=0) ? DRAW_LINE      : DRAW_NONE;
      int hstyle = ((DisplayType&_disHis)!=0) ? DRAW_HISTOGRAM : DRAW_NONE;
      int astyle = ((DisplayType&_disDot)!=0) ? DRAW_ARROW     : DRAW_NONE;
         SetIndexBuffer(0,histou);  SetIndexStyle(0,hstyle,EMPTY,BarsWidth);
         SetIndexBuffer(1,histod);  SetIndexStyle(1,hstyle,EMPTY,BarsWidth);
         SetIndexBuffer(2,rema);    SetIndexStyle(2,lstyle,EMPTY,LinesWidth);
         SetIndexBuffer(3,remda);   SetIndexStyle(3,lstyle,EMPTY,LinesWidth);
         SetIndexBuffer(4,remdb);   SetIndexStyle(4,lstyle,EMPTY,LinesWidth);
         SetIndexBuffer(5,arrowu);  SetIndexStyle(5,astyle); SetIndexArrow(5,ArrowCodeUp);
         SetIndexBuffer(6,arrowd);  SetIndexStyle(6,astyle); SetIndexArrow(6,ArrowCodeDn);
         SetIndexBuffer(7,slope);
         SetIndexBuffer(8,count);
            indicatorFileName   = WindowExpertName();
            TimeFrame           = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Regularized ema ("+(string)Length+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1); count[0] = limit;
            if (TimeFrame!=_Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(8,0)*TimeFrame/_Period));
               if (slope[limit]==-1) CleanPoint(limit,remda,remdb);
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     rema[i]   = _mtfCall(2,y);
                     remda[i]  = EMPTY_VALUE;
                     remdb[i]  = EMPTY_VALUE;
                     arrowu[i] = EMPTY_VALUE;
                     arrowd[i] = EMPTY_VALUE;
                     histou[i] = EMPTY_VALUE;
                     histod[i] = EMPTY_VALUE;
                     slope[i]  = (i<Bars-1) ? (rema[i]>rema[i+1]) ? 1 :  (rema[i]< rema[i+1]) ? -1 : slope[i+1] : 0;
                     if (slope[i]==-1) { histou[i] = Low[i]; histod[i] = High[i]; }
                     if (slope[i]== 1) { histod[i] = Low[i]; histou[i] = High[i]; }
                     if (i<Bars-1 && slope[i]!=slope[i+1])
                     {
                        if (slope[i] ==  1) arrowu[i] = MathMin(rema[i],Low[i] )-iATR(NULL,0,15,i)*ArrowGapUp;
                        if (slope[i] == -1) arrowd[i] = MathMax(rema[i],High[i])+iATR(NULL,0,15,i)*ArrowGapDn;
                     }
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

                     //
                     //
                     //
                     //
                     //

                     int n,s; datetime time = iTime(NULL,TimeFrame,y);
                        for(n = 1; i+n<Bars && Time[i+n] >= time; n++) continue;
                        for(s = 1; i+n<Bars && i+s<Bars && s<n; s++) 
  	                        rema[i+s] = rema[i] + (rema[i+n] - rema[i])* s/n;
            }       
   	      for(int i=limit; i>=0; i--) if (slope[i]==-1) PlotPoint(i,remda,remdb,rema);
            return(0);
         }

   //
   //
   //
   //
   //

   int    tperiod = (FilterPeriod>0) ? FilterPeriod : Length;
   double pfilter = ((FilterOn&_fltPrc)!=0) ? Filter : 0;
   double vfilter = ((FilterOn&_fltVal)!=0) ? Filter : 0;
   double alpha   = 2.0 / (1.0+Length);      
   double regf1   = (1.0+Lambda*2.0);
   double regf2   = (1.0+Lambda);
   if (slope[limit]==-1) CleanPoint(limit,remda,remdb);
   for(int i=limit; i>=0; i--) 
   {
      double price = iFilter(getPrice(Price,Open,Close,High,Low,i,Bars),pfilter,tperiod,i,0);
             rema[i]   = (i<Bars-2) ? iFilter((regf1*rema[i+1]+alpha*(price-rema[i+1])-Lambda*rema[i+2])/regf2,vfilter,tperiod,i,1) : price;
             slope[i]  = (i<Bars-1) ? (rema[i]>rema[i+1]) ? 1 :  (rema[i]< rema[i+1]) ? -1 : slope[i+1] : 0;
             remda[i]  = EMPTY_VALUE;
             remdb[i]  = EMPTY_VALUE;
             arrowu[i] = EMPTY_VALUE;
             arrowd[i] = EMPTY_VALUE;
             histou[i] = EMPTY_VALUE;
             histod[i] = EMPTY_VALUE;
               if (slope[i]==-1) { histou[i] = Low[i]; histod[i] = High[i]; }
               if (slope[i]== 1) { histod[i] = Low[i]; histou[i] = High[i]; }
               if (i<Bars-1 && slope[i]!=slope[i+1])
               {
                  if (slope[i] ==  1) arrowu[i] = MathMin(rema[i],Low[i] )-iATR(NULL,0,15,i)*ArrowGapUp;
                  if (slope[i] == -1) arrowd[i] = MathMax(rema[i],High[i])+iATR(NULL,0,15,i)*ArrowGapDn;
               }
               if (slope[i]==-1) PlotPoint(i,remda,remdb,rema);
   }  
   manageAlerts(); 
   return(0);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define filterInstances 2
double workFil[][filterInstances*3];

#define _fchange 0
#define _fachang 1
#define _fprice  2

double iFilter(double tprice, double filter, int period, int i, int instanceNo=0)
{
   if (filter<=0) return(tprice);
   if (ArrayRange(workFil,0)!= Bars) ArrayResize(workFil,Bars); i = Bars-i-1; instanceNo*=3;
   
   //
   //
   //
   //
   //
   
   workFil[i][instanceNo+_fprice]  = tprice; if (i<1) return(tprice);
   workFil[i][instanceNo+_fchange] = MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]);
   workFil[i][instanceNo+_fachang] = workFil[i][instanceNo+_fchange];

   for (int k=1; k<period && (i-k)>=0; k++) workFil[i][instanceNo+_fachang] += workFil[i-k][instanceNo+_fchange];
                                            workFil[i][instanceNo+_fachang] /= period;
    
   double stddev = 0; for (int k=0;  k<period && (i-k)>=0; k++) stddev += MathPow(workFil[i-k][instanceNo+_fchange]-workFil[i-k][instanceNo+_fachang],2);
          stddev = MathSqrt(stddev/(double)period); 
   double filtev = filter * stddev;
   if( MathAbs(workFil[i][instanceNo+_fprice]-workFil[i-1][instanceNo+_fprice]) < filtev ) workFil[i][instanceNo+_fprice]=workFil[i-1][instanceNo+_fprice];
        return(workFil[i][instanceNo+_fprice]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar]== 1) doAlert(whichBar,"slope changed to up");
         if (slope[whichBar]==-1) doAlert(whichBar,"slope changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" regularized ema "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," regularized ema "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," regularized ema "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _prHABF(_prtype) (_prtype>=pr_habclose && _prtype<=pr_habtbiased2)
#define _priceInstances     1
#define _priceInstancesSize 4
double  _priceWorkHa[][_priceInstances*_priceInstancesSize];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(_priceWorkHa,0)!= Bars) ArrayResize(_priceWorkHa,Bars); instanceNo*=_priceInstancesSize; int r = #ifdef __MQL4__ bars-i-1 #else i #endif;
         
         //
         //
         //
         //
         //
         
         double haOpen  = (r>0) ? (_priceWorkHa[r-1][instanceNo+2] + _priceWorkHa[r-1][instanceNo+3])/2.0 : (open[i]+close[i])/2;;
         double haClose = (open[i]+high[i]+low[i]+close[i]) / 4.0;
         if (_prHABF(tprice))
               if (high[i]!=low[i])
                     haClose = (open[i]+close[i])/2.0+(((close[i]-open[i])/(high[i]-low[i]))*MathAbs((close[i]-open[i])/2.0));
               else  haClose = (open[i]+close[i])/2.0; 
         double haHigh  = fmax(high[i], fmax(haOpen,haClose));
         double haLow   = fmin(low[i] , fmin(haOpen,haClose));

         //
         //
         //
         //
         //
         
         if(haOpen<haClose) { _priceWorkHa[r][instanceNo+0] = haLow;  _priceWorkHa[r][instanceNo+1] = haHigh; } 
         else               { _priceWorkHa[r][instanceNo+0] = haHigh; _priceWorkHa[r][instanceNo+1] = haLow;  } 
                              _priceWorkHa[r][instanceNo+2] = haOpen;
                              _priceWorkHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:
            case pr_habclose:    return(haClose);
            case pr_haopen:   
            case pr_habopen:     return(haOpen);
            case pr_hahigh: 
            case pr_habhigh:     return(haHigh);
            case pr_halow:    
            case pr_hablow:      return(haLow);
            case pr_hamedian:
            case pr_habmedian:   return((haHigh+haLow)/2.0);
            case pr_hamedianb:
            case pr_habmedianb:  return((haOpen+haClose)/2.0);
            case pr_hatypical:
            case pr_habtypical:  return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:
            case pr_habweighted: return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:  
            case pr_habaverage:  return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
            case pr_habtbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
            case pr_habtbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}
