
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DarkGreen
#property indicator_color2  C'150,0,0'
#property indicator_width1  5
#property indicator_width2  5
#property indicator_minimum 0
#property indicator_maximum 1.3

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    FastMa          = 5;
extern int    FastMaMethod    = 3;
extern int    FastMaPrice     = 6;
extern int    FastMaShift     = 0;
extern int    SlowMa          = 40;
extern int    SlowMaMethod    = 3;
extern int    SlowMaPrice     = 6;
extern int    SlowMaShift     = 0;
extern int    SlowestMa       = 200;
extern int    SlowestMaMethod = 3;        //0=MODE_SMA, 1=MODE_EMA,2=MODE_SMMA, 3=MODE_LWMA
extern int    SlowestMaPrice  = 6;
extern int    SlowestMaShift  = 0;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

extern bool   showValues            = false;
extern double Valueloc              = .6;
extern string valueIdentifier       = "3MA-Hist-val";
extern color  txtUpColor            = LawnGreen; //SkyBlue; //Green;
extern color  txtDownColor          = Crimson; //Magenta; //Crimson; //Red;


extern bool   verticalLinesVisible     = false;
extern string LineIdentifier           = "3MA-Hist-lines";
extern color  verticalLinesUpColor     = LawnGreen; //DeepSkyBlue;
extern color  verticalLinesDownColor   = PaleVioletRed;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;
//












//
//
//
//
//

double UpH[];
double DnH[]; 
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(3);   
   SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   
      //
      //
      //
      //
      //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame); 
        
      //
      //
      //
      //
      //
     
     IndicatorShortName(timeFrameToString(timeFrame)+"RK-3MA Cross hist");
     
return(0);
}  

//
//
//
//
//

int deinit() 
{  
   
   if (showValues) deleteValues();
 
   if(verticalLinesVisible) deleteLines();
  
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--)
     {
        double fastMA = iMA(NULL,0,FastMa,FastMaShift,FastMaMethod,FastMaPrice,i);
        double slowMA = iMA(NULL,0,SlowMa,SlowMaShift,SlowMaMethod,SlowMaPrice,i);
        double slowestMA = iMA(NULL,0,SlowestMa,SlowestMaShift,SlowestMaMethod,SlowestMaPrice,i);
        UpH[i]   = EMPTY_VALUE;
        DnH[i]   = EMPTY_VALUE; 
        trend[i] = trend[i+1];
           if (fastMA>slowMA && slowMA>slowestMA) trend[i] = 1;
           if (fastMA<slowMA && slowMA<slowestMA) trend[i] =-1;
           if (trend[i] == 1) UpH[i] = 1;
           if (trend[i] ==-1) DnH[i] = 1;
      manageLines(i);       
      manageValue(i);     
   }
   
   manageAlerts();
         return(0);
      }
      
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,FastMaShift,FastMaMethod,FastMaPrice,SlowMa,SlowMaShift,SlowMaMethod,SlowMaPrice,2,y);
            UpH[i]   = EMPTY_VALUE;
            DnH[i]   = EMPTY_VALUE;   
         if (trend[i] == 1) UpH[i] = 1;
         if (trend[i] ==-1) DnH[i] = 1;   
      }
      manageAlerts();  
return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


void manageAlerts()
{
   if (alertsOn)
   {
   if (!calculateValue && alertsOn)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert("up");
         if (trend[whichBar] ==-1) doAlert("down");
      }         
   }
}   

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ma Cross Histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ma Cross Histo "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//| Rk Added Apr 10, 2014                                                                  
//+-------------------------------------------------------------------
void manageValue(int i)
{
   if (showValues)
   {
      double dist = iATR(NULL,0,20,i)/Valueloc;
      string on = valueIdentifier+":"+Time[i];
      ObjectDelete(on);         
                
      if (trend[i] != trend[i+1])
         {
            if (trend[i] == 1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[i], Low[i] - dist);
              ObjectSetText(on, DoubleToStr(Close[i], Digits) + " " 
              + TimeToStr(Time[i], TIME_MINUTES), 10, "Arial", txtUpColor);
            }
            else
            if (trend[i] == -1)
            {
              ObjectCreate(on, OBJ_TEXT, 0, Time[i], High[i] + dist);
              ObjectSetText(on, DoubleToStr(Close[i], Digits) + " " 
              + TimeToStr(Time[i], TIME_MINUTES), 10, "Arial", txtDownColor);
            }
         }
   }
}


void deleteValues()
{
   string lookFor       = valueIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteValues(datetime time)
{
   string lookFor = valueIdentifier+":"+time; ObjectDelete(lookFor);
}

//+-------------------------------------------------------------------
//| Rk Added Apr 22, 2014                                                                  
//+-------------------------------------------------------------------

void manageLines(int i)
{
   if (verticalLinesVisible )
   {
         deleteLines(Time[i]);
         if (trend[i]!=trend[i+1])
         {
            if (trend[i+1] == -1 && trend[i] !=-1) drawLines(i,verticalLinesUpColor);
            if (trend[i+1] ==  1 && trend[i] != 1) drawLines(i,verticalLinesDownColor);
         }
   }
}

 //

void drawLines(int i,color theColor)
{
    string name = LineIdentifier+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//
void deleteLines()
{
   string lookFor       = LineIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteLines(datetime time)
{
   string lookFor = LineIdentifier+":"+time; ObjectDelete(lookFor);
}
              