//+------------------------------------------------------------------+
//|                                                         alma.mq4 |
//|                                              converted by mladen |
//|                                               mladenfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//

extern ENUM_TIMEFRAMES TimeFrame         = PERIOD_CURRENT;
extern int             AlmaPeriod        = 14;
extern double          AlmaSigma         = 6.0;
extern double          AlmaSample        = 0.25;
extern ENUM_APPLIED_PRICE AlmaPrice      = PRICE_CLOSE;
extern bool            arrowsVisible     = true;
extern bool            arrowsOnFirst     = false;
extern string          arrowsIdentifier  = "alma arrows1";
extern double          arrowsUpperGap    = 0.5;
extern double          arrowsLowerGap    = 0.5;
extern color           arrowsUpColor     = clrLimeGreen;
extern color           arrowsDnColor     = clrRed;
extern int             arrowsUpCode      = 241;
extern int             arrowsDnCode      = 242;
extern int             arrowsUpSize      = 1;
extern int             arrowsDnSize      = 1;
extern bool            alertsOn          = true;
extern bool            alertsOnCurrent   = false;
extern bool            alertsMessage     = true;
extern bool            alertsSound       = false;
extern bool            alertsNotify      = false;
extern bool            alertsEmail       = false;
extern string          soundFile         = "alert2.wav";
//
//
//
//
//

double Alma[];
double Almada[];
double Almadb[];
double slope[];
double coeffs[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,Almada); SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,Almadb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Alma);
   SetIndexBuffer(3,slope);
   
   //
   //
   //
   //
   //
   
      AlmaPeriod = MathMax(AlmaPeriod,1);
      ArrayResize(coeffs,AlmaPeriod);
      
         double m = MathFloor(AlmaSample * (AlmaPeriod - 1.0));
         double s = AlmaPeriod/AlmaSigma;
         for (int i=0; i<AlmaPeriod; i++)
            coeffs[i] = MathExp(-((i-m)*(i-m))/(2.0*s*s));
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame==-99;
            TimeFrame         = MathMax(TimeFrame,_Period);

   //
   //
   //
   //
   //
         
   IndicatorShortName(timeFrameToString(TimeFrame)+" Alma ("+AlmaPeriod+","+DoubleToStr(AlmaSigma,2)+","+DoubleToStr(AlmaSample,2)+")");
   return(0);
}
int deinit() 
{ 
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Almada[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
	  for(int i = limit; i >= 0; i--)
     {
        double sum=0;
        double div=0;
        for (int k=0; k<AlmaPeriod && (k+i)<Bars; k++)
        {
           sum += coeffs[k]*iMA(NULL,0,1,0,MODE_SMA,AlmaPrice,i+k);
           div += coeffs[k];
        }
      
        //
        //
        //
        //
        //
      
        Almada[i] = EMPTY_VALUE;
        Almadb[i] = EMPTY_VALUE;
        if (div!=0)
              Alma[i] = sum/div;
        else  Alma[i] = 0;       
        slope[i] = slope[i+1];
        if (Alma[i]>Alma[i+1]) slope[i] =  1;
        if (Alma[i]<Alma[i+1]) slope[i] = -1;
        if (slope[i]== 1) Almada[i] = 1;
        if (slope[i]==-1) Almadb[i] = 1;
      
        //
        //
        //
        //
        //
      
        if (arrowsVisible)
        {
          ObjectDelete(arrowsIdentifier+":"+Time[i]);
          if (slope[i] != slope[i+1])
          {
            if (slope[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
            if (slope[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
          }
      
         }
   }
   
   //
   //
   //
   //
   //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (slope[whichBar] != slope[whichBar+1])
      if (slope[whichBar] == 1)
            doAlert("sloping up");
      else  doAlert("sloping down");       
    }
   return(0);
   }
   
   //
   //
   //
   //
   //       
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          Almada[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AlmaPeriod,AlmaSigma,AlmaSample,AlmaPrice,arrowsVisible,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
          Almadb[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,AlmaPeriod,AlmaSigma,AlmaSample,AlmaPrice,arrowsVisible,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);                         
   }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+ arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] - arrowsLowerGap * gap);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Alma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Alma "),message);
             if (alertsNotify)  SendNotification(message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

