//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property strict
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_label1  "Double Sma"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrMediumSeaGreen
#property indicator_width1  2
#property indicator_label2  "First Triple Sma"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrOrangeRed
#property indicator_width2  2
#property indicator_label3  "Second Triple Sma"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrMediumOrchid
#property indicator_width3  2
//
//
//
//
//

input int                DSmaPeriod  = 35;
input int                TSmaPeriod1 = 35;
input int                TSmaPeriod2 = 55;
input ENUM_APPLIED_PRICE SmaPrice    = PRICE_CLOSE;

double dsma[],t1sma[],t2sma[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int OnInit()
{
   SetIndexBuffer(0,dsma, INDICATOR_DATA);
   SetIndexBuffer(1,t1sma,INDICATOR_DATA);
   SetIndexBuffer(2,t2sma,INDICATOR_DATA);
return(INIT_SUCCEEDED);
}
int OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int limit=fmin(rates_total-prev_calculated+1,rates_total-1); 

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--) 
   {
      double dsma1 = iSma(iMA(NULL,0,1,0,MODE_SMA,SmaPrice,i),DSmaPeriod,i, rates_total,0);
      double dsma2 = iSma(dsma1                              ,DSmaPeriod,i, rates_total,1);
      double tsma1 = iSma(iMA(NULL,0,1,0,MODE_SMA,SmaPrice,i),TSmaPeriod1,i,rates_total,2);
      double tsma2 = iSma(tsma1                              ,TSmaPeriod1,i,rates_total,3);
      double tsma3 = iSma(tsma2                              ,TSmaPeriod1,i,rates_total,4);
      double tsma4 = iSma(iMA(NULL,0,1,0,MODE_SMA,SmaPrice,i),TSmaPeriod2,i,rates_total,5);
      double tsma5 = iSma(tsma4                              ,TSmaPeriod2,i,rates_total,6);
      double tsma6 = iSma(tsma5                              ,TSmaPeriod2,i,rates_total,7);
      dsma[i]  = 2.0*dsma1 - dsma2;
      t1sma[i] = 3.0*tsma1 - 3.0*tsma2 + tsma3;
      t2sma[i] = 3.0*tsma4 - 3.0*tsma5 + tsma6;
      
   }      
return(rates_total);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSma[][16];
double iSma(double price, int period, int r, int bars, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= bars) ArrayResize(workSma,bars); r = bars-r-1; instanceNo *= 2;

   workSma[r][instanceNo+0] = price;
   double avg = price; int k=1;  for(; k<period && (r-k)>=0; k++) avg += workSma[r-k][instanceNo+0];  
return(avg/(double)k);
}



