//+------------------------------------------------------------------+
//| M5 EMA Scalping Strategy                                         |
//| https://www.youtube.com/watch?v=zhEukjCzXwM                      |
//| 
//| not for sale, rent, auction, nor lease                           |
//+------------------------------------------------------------------+
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"

#property indicator_chart_window
#property indicator_buffers 11
#property indicator_color1   clrPaleGreen //up histogram for M5 EMA 8
#property indicator_color2   clrPink      //down histogram for M5 EMA 21
#property indicator_color3   clrPaleGreen //up histogram for H1 EMA 8
#property indicator_color4   clrPink      //down histogram for H1 EMA 21

#property indicator_color5   clrCyan      //uptrend line for M5 EMA 8
#property indicator_color6   clrBlue      //uptrend line for M5 EMA 8
#property indicator_color7   clrRed       //downtrend line for M5 EMA 21
#property indicator_color8   clrDarkGreen //uptrend line for H1 EMA 8
#property indicator_color9   clrCrimson   //downtrend line for H1 EMA 21 

#property indicator_color10  clrBlue      //up arrow
#property indicator_color11  clrMagenta   //down arrow

#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2 //H1 EMA8; histogram width
#property indicator_width4  2 //H1 EMA21; histogram width
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  1
#property indicator_width9  1

#property indicator_style6  STYLE_DOT

extern int nMaxBars                         = 350;          // maximum number of bars to calculate, 0: no limit
extern string             note1             ="------------------------------------------";
extern int                MA1Period         = 8;            // Fast ma period
extern ENUM_MA_METHOD     MA1Method         = MODE_EMA;     // Fast ma mode
extern ENUM_APPLIED_PRICE MA1Price          = PRICE_CLOSE;  // Fast ma price
extern int                MA1Shift          = 0;            // Fast ma shift
extern string             note2             ="------------------------------------------";
extern int                MA2Period         = 13;           // Medium ma period
extern ENUM_MA_METHOD     MA2Method         = MODE_EMA;     // Medium ma mode
extern ENUM_APPLIED_PRICE MA2Price          = PRICE_CLOSE;  // Medium ma price
extern int                MA2Shift          = 0;            // Medium ma shift
extern string             note3             ="------------------------------------------";
extern int                MA3Period         = 21;           // Slow ma period
extern ENUM_MA_METHOD     MA3Method         = MODE_EMA;     // Slow ma mode
extern ENUM_APPLIED_PRICE MA3Price          = PRICE_CLOSE;  // Slow ma price
extern int                MA3Shift          = 0;            // Slow ma shift
extern string             note4             ="------------------------------------------";
extern int                MAfontCode4       = 167;
extern int                MAfontCode5       = 167;
extern string             note5             ="------------------------------------------";
extern int                UpArrowFontCode   = 233;
extern int                DownArrowFontCode = 234;
extern double             ArrowGapUp        = 0.5;          // Up arrow gap       
extern double             ArrowGapDn        = 0.5;          // Down arrow gap
extern string             note6             ="------------------------------------------";
extern bool               alertsOn          = false;        // Turn alerts on/off?
extern bool               alertsOnCurrent   = false;        // Alerts on still opened bar on/off?
extern bool               alertsMessage     = false;        // Alerts message on/off?
extern bool               alertsSound       = false;        // Alerts sound on/off?
extern bool               alertsPushNotif   = false;        // Alerts push notification on/off?
extern bool               alertsEmail       = false;        // Alerts email on/off?
extern string             soundFile         = "alert2.wav"; // Sound file

int   MA4Period = MA1Period;
int   MA4Method = MODE_EMA;
int   MA4Price  = PRICE_CLOSE;
int   MA4Shift  = 0;

int   MA5Period = MA3Period;
int   MA5Method = MODE_EMA;
int   MA5Price  = PRICE_CLOSE;
int   MA5Shift  = 0;

double MAuptrendHistogram1[], MAdowntrendHistogram1[], SlowMovingAverage1[], MediumMovingAverage2[], FastMovingAverage3[], MAuptrendHistogram2[], MAdowntrendHistogram2[], H1MA4[], H1MA5[];
string TimeFrame = "Current time frame";
int    timeFrame;
double CrossUp[],CrossDn[],trend[];
//+------------------------------------------------------------------+
int OnInit()
{
   IndicatorBuffers(12);
   SetIndexBuffer(0, MAuptrendHistogram2);    SetIndexStyle(0,DRAW_HISTOGRAM); //H1 MA 8 histogram
   SetIndexBuffer(1, MAdowntrendHistogram2);  SetIndexStyle(1,DRAW_HISTOGRAM); //H1 MA 21 histogram
   SetIndexBuffer(2, MAuptrendHistogram1);    SetIndexStyle(2,DRAW_HISTOGRAM); //M5 MA 8 histogram
   SetIndexBuffer(3, MAdowntrendHistogram1);  SetIndexStyle(3,DRAW_HISTOGRAM); //M5 MA 21 histogram
   SetIndexBuffer(4, SlowMovingAverage1); 
   SetIndexBuffer(5, MediumMovingAverage2);   
   SetIndexBuffer(6, FastMovingAverage3); 
   
   SetIndexBuffer(7, H1MA4); 
   SetIndexStyle (7, DRAW_ARROW);
   SetIndexArrow (7, MAfontCode4); //H1 MA 8

   SetIndexBuffer(8, H1MA5); 
   SetIndexStyle (8, DRAW_ARROW);
   SetIndexArrow (8, MAfontCode5); //H1 MA 21

   SetIndexBuffer(9, CrossUp); SetIndexStyle(9, DRAW_ARROW); SetIndexArrow(9, UpArrowFontCode); 
   SetIndexBuffer(10,CrossDn); SetIndexStyle(10,DRAW_ARROW); SetIndexArrow(10,DownArrowFontCode);   
   SetIndexBuffer(11,trend);

   if ( Period() == PERIOD_M1 )
      {
        MA4Period = MA4Period * 60; // 480;
        MA5Period = MA5Period * 60; // 1260;
      }
   else 
   if ( Period() == PERIOD_M5 )
      {
        MA4Period = MA4Period * 12; // 96;
        MA5Period = MA5Period * 12; // 252;
      }
   else 
   if ( Period() == PERIOD_M15 )
      {
        MA4Period = MA4Period * 4; // 32;
        MA5Period = MA5Period * 4; // 84;
      }
   else
   if ( Period() == PERIOD_M30 )
      {
        MA4Period = MA4Period * 2; // 16;
        MA5Period = MA5Period * 2; // 42;
      }

   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" MA Shades");

return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//int start()
int OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   if (nMaxBars > 0) 
	    limit = MathMin(limit, nMaxBars);
    
   for(int i=limit; i>=0; i--)
   {
      int y                    = iBarShift(NULL,timeFrame,Time[i]);
      double banzaiMA1         = iMA(NULL,timeFrame,MA1Period,0,MA1Method,MA1Price,y+MA1Shift);
      double banzaiMA2         = iMA(NULL,timeFrame,MA2Period,0,MA2Method,MA2Price,y+MA2Shift);
      double banzaiMA3         = iMA(NULL,timeFrame,MA3Period,0,MA3Method,MA3Price,y+MA3Shift);
      double banzaiMA4         = iMA(NULL,timeFrame,MA4Period,0,MA4Method,MA4Price,y+MA4Shift);
      double banzaiMA5         = iMA(NULL,timeFrame,MA5Period,0,MA5Method,MA5Price,y+MA5Shift);
 
      MAuptrendHistogram1[i]   = banzaiMA1;
      MAdowntrendHistogram1[i] = banzaiMA3;
      SlowMovingAverage1[i]    = banzaiMA1;
      MediumMovingAverage2[i]  = banzaiMA2;
      FastMovingAverage3[i]    = banzaiMA3;
            
      MAuptrendHistogram2[i]   = banzaiMA4;
      MAdowntrendHistogram2[i] = banzaiMA5;
      H1MA4[i]                 = banzaiMA4;
      H1MA5[i]                 = banzaiMA5;      
      
      CrossUp[i]               = EMPTY_VALUE;
      CrossDn[i]               = EMPTY_VALUE;
      if ((banzaiMA1>banzaiMA2) && (banzaiMA1>banzaiMA3) && (banzaiMA1>banzaiMA4) && (banzaiMA4>banzaiMA5))
         trend[i] = 1;
      else
      if ((banzaiMA1<banzaiMA2) && (banzaiMA1<banzaiMA3) && (banzaiMA1<banzaiMA4) && (banzaiMA4<banzaiMA5))
         trend[i] = -1;
         
      if (i<rates_total-1 && trend[i]!=trend[i+1])
      {
            if (trend[i] ==  1) CrossUp[i] = Low[i] -iATR(NULL,0,15,i)*ArrowGapUp;
            if (trend[i] == -1) CrossDn[i] = High[i]+iATR(NULL,0,15,i)*ArrowGapDn;
      }    
      
   }
   if (alertsOn)
      {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
         if (trend[whichBar] != trend[whichBar+1])
            {
              if (trend[whichBar] == 1) doAlert(" crossed up");
              if (trend[whichBar] ==-1) doAlert(" crossed down");       
            }         
      }              
   return(rates_total);
}
//+-------------------------------------------------------------------
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
//+------------------------------------------------------------------+
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//+------------------------------------------------------------------+
string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
//+------------------------------------------------------------------+
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" MA "+doWhat;
             if (alertsMessage)    Alert(message);
             if (alertsPushNotif)  SendNotification(message);
             if (alertsEmail)      SendMail(_Symbol+" MA Cross ",message);
             if (alertsSound)      PlaySound(soundFile);
      }
}
//+------------------------------------------------------------------+
