//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property strict

//
//
//
//
//

extern int      CalcPeriod = 35;              // Calculation period
extern color    ColorUp    = clrDeepSkyBlue;  // Color for up trend
extern color    ColorDown  = clrSandyBrown;   // Color for down trend
extern int      LinesWidth = 2;               // Lines width for lines
extern int      BodyWidth  = 2;               // Body width for candles

double val1[],val2[],val3[],val4[],val0[],trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   SetIndexBuffer(2,val3);
   SetIndexBuffer(3,val4);
   SetIndexBuffer(4,val0);
   SetIndexBuffer(5,trend);
   return(0);
}

int start()
{
   static long sChartStyle=-1;
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //

      long chartStyle; ChartGetInteger(0,CHART_MODE,0,chartStyle);
      if (sChartStyle != chartStyle)
      {
         sChartStyle=chartStyle; limit=Bars-1;
         switch ((int)chartStyle)
         {
            case CHART_BARS:
               SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,1,ColorUp);
               SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,1,ColorDown);
               SetIndexStyle(2,DRAW_NONE);
               SetIndexStyle(3,DRAW_NONE);
               break;
            case CHART_LINE:
               SetIndexStyle(0,DRAW_LINE,EMPTY,LinesWidth,ColorUp);
               SetIndexStyle(1,DRAW_LINE,EMPTY,LinesWidth,ColorDown);
               SetIndexStyle(2,DRAW_LINE,EMPTY,LinesWidth,ColorDown);
               SetIndexStyle(3,DRAW_NONE);
               break;
            default :               
               SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,1        ,ColorUp);
               SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,1        ,ColorDown);
               SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,BodyWidth,ColorUp);
               SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,BodyWidth,ColorDown);
         }
      }
      
      //
      //
      //
      //
      //

      if (chartStyle==CHART_LINE) CleanPoint(limit,val2,val3);      
      for(int i = limit; i >= 0; i--)
      {
         double emah  = iEma(High[i],CalcPeriod,i,0);
         double emal  = iEma(Low[i] ,CalcPeriod,i,1);
         val0[i]  = iEma(Close[i],CalcPeriod,i,2);
         val1[i]  = EMPTY_VALUE;
         val2[i]  = EMPTY_VALUE;
         val3[i]  = EMPTY_VALUE;
         val4[i]  = EMPTY_VALUE;
         trend[i] = 0; 
         if (emah<Close[i]) trend[i] =  1;
         if (emal>Close[i]) trend[i] = -1;
         if (trend[i]==1)
         {
            val3[i] = MathMax(Open[i],Close[i]);
            val4[i] = MathMin(Open[i],Close[i]);
            if (chartStyle!=CHART_LINE)
            {
               val1[i] = High[i];
               val2[i] = Low[i];
            }
            else
            {
               val1[i] = val0[i];
               val2[i] = EMPTY_VALUE;
               val3[i] = EMPTY_VALUE;
            }
         }
         if (trend[i]==-1)
         {
            val3[i] = MathMin(Open[i],Close[i]);
            val4[i] = MathMax(Open[i],Close[i]);
            if (chartStyle!=CHART_LINE)
            {
               val2[i] = High[i];
               val1[i] = Low[i];
            }
            else { val1[i] = val0[i]; PlotPoint(i,val2,val3,val0); }
         }
      }
   return(0);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][3];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   workEma[r][instanceNo] = price;
   double alpha = 2.0 / (1.0+period);
   if (r>0)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}