//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------
#property indicator_chart_window

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
};
enum enFilterWhat
{
   flt_prc,  // Filter the price
   flt_val,  // Filter the non lag ma value
   flt_both  // Filter both
};


extern bool		    ShowCurrentPairOnly= false;                                     //	Dispaly only chart Pair
extern string	    PairsToTrade       = "EURUSD,GBPUSD,AUDUSD,NZDUSD,USDCAD,USDCHF,USDJPY,EURJPY,GBPJPY,CHFJPY,CADJPY,AUDJPY,NZDJPY";
extern string	    PeriodsToTrade     = "M1,M5,M15,M30,H1,H4";                     // Time Frames to display are user defined

extern string	    pdi                = "----Pair display inputs----";
extern int		    FontSize           = 10;
extern color	    FontColour         = clrYellow;
extern string	    Font_Font          = "Lucida Sans Unicode";
extern double	    DisplayStarts_X    = 5;	                                        // we positioning the object from the top right corner of window
extern double	    DisplayStarts_Y    = 15;
extern ENUM_BASE_CORNER  corner       = 1;
extern bool		    IndicatorInWindow  = false;	                                  // Dispaly the indicator in Window
extern string	     AS_WindowName     = "non lag ma histo";                        //  Window ShortName
extern int          NlmPeriod         = 25;                                        // Non lag ma period
extern enPrices     NlmPrice          = pr_close;                                  // Price to use
extern double       Filter            =  0;                                        // Filter to use (<=0 no filter)
extern int          FilterPeriod      =  0;                                        // Filter period (<=0 use Non lag ma period)
extern enFilterWhat FilterOn          = flt_prc;                                   // Apply filter to
extern int          bar               = 0;

extern int	        symbolCodeSUP     = 233;
extern int	        symbolCodeSDN     = 234;
extern int		     symbolCodeNoTrade = 232;
extern color	     colorCodeSUP      = clrBlue;
extern color        colorCodeSDN      = clrRed;
extern color	     colorCodeNoTrade  = clrWhite;

extern int          alertWhen         = 2;
extern bool         alertImmediate    = true;
extern bool         alertsOn          = true;
extern bool         alertsMessage     = true;
extern bool         alertsSound       = false;
extern bool         alertsEmail       = false;

//
//
//
//
//

double   trendStates[][2];
string	TradePair[];			   //Array to hold the pairs traded by the user
string	TradePeriod[];			   //Array to hold the periods traded by the user
int		TradePeriodTF[];	   	//Array to hold the periods traded by the user
int		TradeTrendSymbol[][9];	//Array to hold the pairs trend symbol
color 	TradeTrendColor[][9];	//Array to hold the pairs trend color
bool  	AlertSent[];

//
//
//
//
//

int		NoOfPairs;				 // Holds the number of pairs passed by the user via the inputs screen
int		NoOfPeriods;			 // Holds the number of periods passed by the user via the inputs screen
int		OldBars;
int      WindowNo;

string   objPrefix;        	 // all objects drawn by this indicator will be prefixed with this
string   buff_str;	          // all objects drawn by this indicator will be prefixed with this
string	trend;

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{

	int j;
	objPrefix = WindowExpertName();
	
	if(IndicatorInWindow)
	{
		WindowNo = WindowFind(AS_WindowName);
		if(WindowNo < 0)
		{
			Alert("non lag ma_WindowName is Wrong");
			return(0);
		}
		DisplayStarts_X = 5;
		DisplayStarts_Y = 5;
	}
   
   //
   //
   //
   //
   //
   
	if(!ShowCurrentPairOnly)
	{
	
		NoOfPairs = StringFindCount(PairsToTrade,",")+1;
		ArrayResize(TradePair, NoOfPairs);
		string AddChar = StringSubstr(Symbol(),6,4);
		StrPairToStringArray(PairsToTrade, TradePair, AddChar);
	}
	else
	{
		
		NoOfPairs = 1;
		ArrayResize(TradePair, NoOfPairs);
		TradePair[0] = Symbol();
	}

   //
   //
   //
   //
   //
   	
	  ArrayResize(trendStates,NoOfPairs);
	  for (int k=0; k<NoOfPairs; k++) trendStates[k][0]=0;

   //
   //
   //
   //
   //
   	  
	NoOfPeriods = StringFindCount(PeriodsToTrade, ",")+1;
	ArrayResize(TradePeriod, NoOfPeriods);
	ArrayResize(TradePeriodTF, NoOfPeriods);
	StrToStringArray(PeriodsToTrade, TradePeriod);
	
	for(j=0; j<NoOfPeriods; j++)
	{
		TradePeriodTF[j] = StrToTF(TradePeriod[j]);	
	}
	
   //	
   //
   //
   //
   //
   
	ArrayResize(TradeTrendSymbol, NoOfPairs);
	ArrayInitialize(TradeTrendSymbol, symbolCodeNoTrade);
	ArrayResize(TradeTrendColor, NoOfPairs);
	ArrayInitialize(TradeTrendColor, colorCodeNoTrade);		
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() {	Comment(""); RemoveObjects(objPrefix);	return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   GetPairTrends(TradeTrendSymbol, TradeTrendColor);
   PrintPairTrends();

return(0);
}

//
//-------------------------------------------------------------------+
//                                                                   |
//-------------------------------------------------------------------+
//
//

void RemoveObjects(string Pref)
{   
	int i;
	string objname = "";

	for (i = ObjectsTotal(); i >= 0; i--)
	{
		objname = ObjectName(i);
		if (StringFind(objname, Pref, 0) > -1) ObjectDelete(objname);
	}
	return;
} 

//+------------------------------------------------------------------+
// StringFindCount                                                   |
//+------------------------------------------------------------------+
//
//

int StringFindCount(string str, string str2)
{
  int c = 0;
  for (int i=0; i<StringLen(str); i++)
    if (StringSubstr(str,i,StringLen(str2)) == str2)  c++;
return(c);
} 

//+------------------------------------------------------------------+
// StrPairToStringArray                                              |
//+------------------------------------------------------------------+
//
//

void StrPairToStringArray(string str, string &a[], string p_suffix, string delim=",")
{
	int z1=-1, z2=0;
	for (int i=0; i<ArraySize(a); i++)
	{
		z2 = StringFind(str,delim,z1+1);
		a[i] = StringSubstr(str,z1+1,z2-z1-1) + p_suffix;
		if (z2 >= StringLen(str)-1)   break;
		z1 = z2;
	}
return;
} 

//+------------------------------------------------------------------+
// StrToStringArray                                                  |
//+------------------------------------------------------------------+
//
//

void StrToStringArray(string str, string &a[], string delim=",")
{
	int z1=-1, z2=0;
	for (int i=0; i<ArraySize(a); i++)
	{
		z2 = StringFind(str,delim,z1+1);
		a[i] = StringSubstr(str,z1+1,z2-z1-1);
		if (z2 >= StringLen(str)-1)   break;
		z1 = z2;
	}
return;
} 

//+------------------------------------------------------------------+
// StrToTF(string str)                                               |
//+------------------------------------------------------------------+
// 
// 

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int StrToTF(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(_Period);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//+------------------------------------------------------------------+
// StringUpper(string str)                                           |
//+------------------------------------------------------------------+
// 
// 

string StringUpper(string str)
{
  string outstr = "";
  string lower  = "abcdefghijklmnopqrstuvwxyz";
  string upper  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  
  //
  //
  //
  //
  //
  
  for(int i=0; i<StringLen(str); i++)  
  {
    int t1 = StringFind(lower,StringSubstr(str,i,1),0);
    if (t1 >=0)  
      outstr = outstr + StringSubstr(upper,t1,1);
    else
      outstr = outstr + StringSubstr(str,i,1);
  }
return(outstr);
}  

//+------------------------------------------------------------------+
//| GetPairTrends                                                    |
//+------------------------------------------------------------------+
//
//

void GetPairTrends(int &trend_symbol[][], color &trend_color[][])
{
	int i, j;
	
	//
	//
	//
	//
	//
	
	for (i=0; i<NoOfPairs; i++)
	{
	   int signalsDn = 0;
	   int signalsUp = 0;
	   
	   //
	   //
	   //
	   //
	   //
	   
		for(j=0; j<NoOfPeriods; j++)
		{
			trend_symbol[i][j] = symbolCodeNoTrade;
			trend_color[i][j]  = colorCodeNoTrade;
			
			//
			//
			//
			//
			//
         
         double nlmaup = iCustom(TradePair[i],TradePeriodTF[j],"non lag ma histo",NlmPeriod,NlmPrice,Filter,FilterPeriod,FilterOn,0,bar); 
         double nlmadn = iCustom(TradePair[i],TradePeriodTF[j],"non lag ma histo",NlmPeriod,NlmPrice,Filter,FilterPeriod,FilterOn,1,bar); 
        
    
         
         //
         //
         //
         //
         //
         
         if (nlmaup != EMPTY_VALUE &&  nlmadn == EMPTY_VALUE)
         { 
			    trend_symbol[i][j] = symbolCodeSUP;
				 trend_color[i][j]  = colorCodeSUP;
				 signalsUp++;
		    }
			 if (nlmaup == EMPTY_VALUE &&  nlmadn != EMPTY_VALUE)
			{
			    trend_symbol[i][j] = symbolCodeSDN;
				 trend_color[i][j]  = colorCodeSDN;
				 signalsDn++;
			 }
		} 
		
		//
		//
		//
		//
		//
		
		if (signalsDn>=alertWhen || signalsUp>=alertWhen)
		{
   		if (!alertImmediate && trendStates[i][0] == 0)
   		{
   		    if (signalsDn >= alertWhen) { trendStates[i][0] = -1; trendStates[i][1] = -1; }
   		    if (signalsUp >= alertWhen) { trendStates[i][0] =  1; trendStates[i][1] =  1; }
   		}
   		else
   		{
   		    if (signalsDn >= alertWhen) trendStates[i][1] = -1;
   		    if (signalsUp >= alertWhen) trendStates[i][1] =  1;
   		    if (trendStates[i][0]!=trendStates[i][1])
   		    {
   		       trendStates[i][0]=trendStates[i][1];
                if (trendStates[i][1]==1)
   		            doAlert(TradePair[i]+" "+alertWhen+" or more signals alligned up");
                else doAlert(TradePair[i]+" "+alertWhen+" or more signals alligned down");  		          
   		    }
   		}
      }   		
	} 
	return;

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   string message;

   if (!alertsOn) return;   
       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," non lag ma trend display ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," non lag ma display "),message);
          if (alertsSound)   PlaySound("alert2.wav");
}

//+------------------------------------------------------------------+
//| PrintPairTrends                                                  |
//+------------------------------------------------------------------+
//
//

void PrintPairTrends()
{
	RemoveObjects(objPrefix);
	
	int i, j;
	
	//
	//
	//
	//
	//
	
	for(i=0; i<NoOfPairs; i++)
	{
		buff_str = StringConcatenate(objPrefix, TradePair[i]);
		ObjectDelete(buff_str);
		ObjectCreate(buff_str,OBJ_LABEL,WindowNo,0,0,0,0);
		ObjectSet(buff_str,OBJPROP_CORNER,corner);
		ObjectSet(buff_str,OBJPROP_XDISTANCE,DisplayStarts_X + FontSize*(NoOfPeriods*2));
		ObjectSet(buff_str,OBJPROP_YDISTANCE,DisplayStarts_Y + (i+1)*(FontSize+FontSize/2));
		ObjectSetText(buff_str,TradePair[i],FontSize-2,Font_Font,FontColour);
	}
	
	//
	//
	//
	//
	//
	
	for(j=0; j<NoOfPeriods; j++)
	{
		buff_str = StringConcatenate(objPrefix, TradePeriod[j]);
		ObjectDelete(buff_str);
		ObjectCreate(buff_str,OBJ_LABEL,WindowNo,0,0,0,0);
		ObjectSet(buff_str,OBJPROP_CORNER,corner);
		ObjectSet(buff_str,OBJPROP_XDISTANCE,DisplayStarts_X + (NoOfPeriods-1-j)*(FontSize*2));
		ObjectSet(buff_str,OBJPROP_YDISTANCE,DisplayStarts_Y);
		ObjectSetText(buff_str,TradePeriod[j],FontSize-2,Font_Font,FontColour);      
	}
	
	//
	//
	//
	//
	//
	
	for(i=0; i<NoOfPairs; i++)
	{
		for(j=0; j<NoOfPeriods; j++)
		{
			buff_str = StringConcatenate(objPrefix, TradePair[i], TradePeriod[j]);
			ObjectDelete(buff_str);
			ObjectCreate(buff_str,OBJ_LABEL,WindowNo,0,0,0,0);
 			ObjectSet(buff_str,OBJPROP_CORNER,corner);
			ObjectSet(buff_str,OBJPROP_XDISTANCE,DisplayStarts_X + (NoOfPeriods-1-j)*(FontSize*2));
			ObjectSet(buff_str,OBJPROP_YDISTANCE,DisplayStarts_Y + (i+1)*(FontSize+FontSize/2));
			ObjectSetText(buff_str,CharToStr(TradeTrendSymbol[i][j]),FontSize,"Wingdings",TradeTrendColor[i][j]);
		}
	}
return;

}




